## qemu 4.2

=== Makefile ===
# Makefile for QEMU.

ifneq ($(words $(subst :, ,$(CURDIR))), 1)
  $(error main directory cannot contain spaces nor colons)
endif

# Always point to the root of the build tree (needs GNU make).
BUILD_DIR=$(CURDIR)

# Before including a proper config-host.mak, assume we are in the source tree
SRC_PATH=.

UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
    html info pdf txt \
    help check-help print-% \
    docker docker-% vm-help vm-test vm-build-%

print-%:
	@echo '$*=$($*)'

# All following code might depend on configuration variables
ifneq ($(wildcard config-host.mak),)
# Put the all: rule here so that config-host.mak can contain dependencies.
all:
include config-host.mak

git-submodule-update:

.PHONY: git-submodule-update

git_module_status := $(shell \
  cd '$(SRC_PATH)' && \
  GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
  echo $$?; \
)

ifeq (1,$(git_module_status))
ifeq (no,$(GIT_UPDATE))
git-submodule-update:
	$(call quiet-command, \
            echo && \
            echo "GIT submodule checkout is out of date. Please run" && \
            echo "  scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
            echo "from the source directory checkout $(SRC_PATH)" && \
            echo && \
            exit 1)
else
git-submodule-update:
	$(call quiet-command, \
          (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
          "GIT","$(GIT_SUBMODULES)")
endif
endif

.git-submodule-status: git-submodule-update config-host.mak

# Check that we're not trying to do an out-of-tree build from
# a tree that's been used for an in-tree build.
ifneq ($(realpath $(SRC_PATH)),$(realpath .))
ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
$(error This is an out of tree build but your source tree ($(SRC_PATH)) \
seems to have been used for an in-tree build. You can fix this by running \
"$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
endif
endif

CONFIG_SOFTMMU := $(if $(filter %-softmmu,$(TARGET_DIRS)),y)
CONFIG_USER_ONLY := $(if $(filter %-user,$(TARGET_DIRS)),y)
CONFIG_XEN := $(CONFIG_XEN_BACKEND)
CONFIG_ALL=y
-include config-all-devices.mak
-include config-all-disas.mak

config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
	@echo $@ is out-of-date, running configure
	@./config.status

# Force configure to re-run if the API symbols are updated
ifeq ($(CONFIG_PLUGIN),y)
config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
endif

else
config-host.mak:
ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
	@echo "Please call configure before running make!"
	@exit 1
endif
endif

include $(SRC_PATH)/rules.mak

# lor is defined in rules.mak
CONFIG_BLOCK := $(call lor,$(CONFIG_SOFTMMU),$(CONFIG_TOOLS))

# Create QEMU_PKGVERSION and FULL_VERSION strings
# If PKGVERSION is set, use that; otherwise get version and -dirty status from git
QEMU_PKGVERSION := $(if $(PKGVERSION),$(PKGVERSION),$(shell \
  cd $(SRC_PATH); \
  if test -e .git; then \
    git describe --match 'v*' 2>/dev/null | tr -d '\n'; \
    if ! git diff-index --quiet HEAD &>/dev/null; then \
      echo "-dirty"; \
    fi; \
  fi))

# Either "version (pkgversion)", or just "version" if pkgversion not set
FULL_VERSION := $(if $(QEMU_PKGVERSION),$(VERSION) ($(QEMU_PKGVERSION)),$(VERSION))

generated-files-y = qemu-version.h config-host.h qemu-options.def

GENERATED_QAPI_FILES = qapi/qapi-builtin-types.h qapi/qapi-builtin-types.c
GENERATED_QAPI_FILES += qapi/qapi-types.h qapi/qapi-types.c
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-types-%.h)
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-types-%.c)
GENERATED_QAPI_FILES += qapi/qapi-builtin-visit.h qapi/qapi-builtin-visit.c
GENERATED_QAPI_FILES += qapi/qapi-visit.h qapi/qapi-visit.c
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-visit-%.h)
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-visit-%.c)
GENERATED_QAPI_FILES += qapi/qapi-commands.h qapi/qapi-commands.c
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-commands-%.h)
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-commands-%.c)
GENERATED_QAPI_FILES += qapi/qapi-emit-events.h qapi/qapi-emit-events.c
GENERATED_QAPI_FILES += qapi/qapi-events.h qapi/qapi-events.c
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-events-%.h)
GENERATED_QAPI_FILES += $(QAPI_MODULES:%=qapi/qapi-events-%.c)
GENERATED_QAPI_FILES += qapi/qapi-introspect.c qapi/qapi-introspect.h
GENERATED_QAPI_FILES += qapi/qapi-doc.texi

generated-files-y += $(GENERATED_QAPI_FILES)

generated-files-y += trace/generated-tcg-tracers.h

generated-files-y += trace/generated-helpers-wrappers.h
generated-files-y += trace/generated-helpers.h
generated-files-y += trace/generated-helpers.c

generated-files-$(CONFIG_TRACE_UST) += trace-ust-all.h
generated-files-$(CONFIG_TRACE_UST) += trace-ust-all.c

generated-files-y += module_block.h

TRACE_HEADERS = trace-root.h $(trace-events-subdirs:%=%/trace.h)
TRACE_SOURCES = trace-root.c $(trace-events-subdirs:%=%/trace.c)
TRACE_DTRACE =
ifdef CONFIG_TRACE_DTRACE
TRACE_HEADERS += trace-dtrace-root.h $(trace-events-subdirs:%=%/trace-dtrace.h)
TRACE_DTRACE += trace-dtrace-root.dtrace $(trace-events-subdirs:%=%/trace-dtrace.dtrace)
endif
ifdef CONFIG_TRACE_UST
TRACE_HEADERS += trace-ust-root.h $(trace-events-subdirs:%=%/trace-ust.h)
endif

generated-files-y += $(TRACE_HEADERS)
generated-files-y += $(TRACE_SOURCES)
generated-files-y += $(BUILD_DIR)/trace-events-all
generated-files-y += .git-submodule-status

trace-group-name = $(shell dirname $1 | sed -e 's/[^a-zA-Z0-9]/_/g')

tracetool-y = $(SRC_PATH)/scripts/tracetool.py
tracetool-y += $(shell find $(SRC_PATH)/scripts/tracetool -name "*.py")

%/trace.h: %/trace.h-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
%/trace.h-timestamp: $(SRC_PATH)/%/trace-events $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=$(call trace-group-name,$@) \
		--format=h \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

%/trace.c: %/trace.c-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
%/trace.c-timestamp: $(SRC_PATH)/%/trace-events $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=$(call trace-group-name,$@) \
		--format=c \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

%/trace-ust.h: %/trace-ust.h-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
%/trace-ust.h-timestamp: $(SRC_PATH)/%/trace-events $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=$(call trace-group-name,$@) \
		--format=ust-events-h \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

%/trace-dtrace.dtrace: %/trace-dtrace.dtrace-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
%/trace-dtrace.dtrace-timestamp: $(SRC_PATH)/%/trace-events $(BUILD_DIR)/config-host.mak $(tracetool-y)
	$(call quiet-command,$(TRACETOOL) \
		--group=$(call trace-group-name,$@) \
		--format=d \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

%/trace-dtrace.h: %/trace-dtrace.dtrace $(tracetool-y)
	$(call quiet-command,dtrace -o $@ -h -s $<, "GEN","$@")

%/trace-dtrace.o: %/trace-dtrace.dtrace $(tracetool-y)


trace-root.h: trace-root.h-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
trace-root.h-timestamp: $(SRC_PATH)/trace-events $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=root \
		--format=h \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

trace-root.c: trace-root.c-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
trace-root.c-timestamp: $(SRC_PATH)/trace-events $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=root \
		--format=c \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

trace-ust-root.h: trace-ust-root.h-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
trace-ust-root.h-timestamp: $(SRC_PATH)/trace-events $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=root \
		--format=ust-events-h \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

trace-ust-all.h: trace-ust-all.h-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
trace-ust-all.h-timestamp: $(trace-events-files) $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=all \
		--format=ust-events-h \
		--backends=$(TRACE_BACKENDS) \
		$(trace-events-files) > $@,"GEN","$(@:%-timestamp=%)")

trace-ust-all.c: trace-ust-all.c-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
trace-ust-all.c-timestamp: $(trace-events-files) $(tracetool-y) $(BUILD_DIR)/config-host.mak
	$(call quiet-command,$(TRACETOOL) \
		--group=all \
		--format=ust-events-c \
		--backends=$(TRACE_BACKENDS) \
		$(trace-events-files) > $@,"GEN","$(@:%-timestamp=%)")

trace-dtrace-root.dtrace: trace-dtrace-root.dtrace-timestamp
	@cmp $< $@ >/dev/null 2>&1 || cp $< $@
trace-dtrace-root.dtrace-timestamp: $(SRC_PATH)/trace-events $(BUILD_DIR)/config-host.mak $(tracetool-y)
	$(call quiet-command,$(TRACETOOL) \
		--group=root \
		--format=d \
		--backends=$(TRACE_BACKENDS) \
		$< > $@,"GEN","$(@:%-timestamp=%)")

trace-dtrace-root.h: trace-dtrace-root.dtrace
	$(call quiet-command,dtrace -o $@ -h -s $<, "GEN","$@")

trace-dtrace-root.o: trace-dtrace-root.dtrace

KEYCODEMAP_GEN = $(SRC_PATH)/ui/keycodemapdb/tools/keymap-gen
KEYCODEMAP_CSV = $(SRC_PATH)/ui/keycodemapdb/data/keymaps.csv

KEYCODEMAP_FILES = \
		 ui/input-keymap-atset1-to-qcode.c \
		 ui/input-keymap-linux-to-qcode.c \
		 ui/input-keymap-qcode-to-atset1.c \
		 ui/input-keymap-qcode-to-atset2.c \
		 ui/input-keymap-qcode-to-atset3.c \
		 ui/input-keymap-qcode-to-linux.c \
		 ui/input-keymap-qcode-to-qnum.c \
		 ui/input-keymap-qcode-to-sun.c \
		 ui/input-keymap-qnum-to-qcode.c \
		 ui/input-keymap-usb-to-qcode.c \
		 ui/input-keymap-win32-to-qcode.c \
		 ui/input-keymap-x11-to-qcode.c \
		 ui/input-keymap-xorgevdev-to-qcode.c \
		 ui/input-keymap-xorgkbd-to-qcode.c \
		 ui/input-keymap-xorgxquartz-to-qcode.c \
		 ui/input-keymap-xorgxwin-to-qcode.c \
		 ui/input-keymap-osx-to-qcode.c \
		 $(NULL)

generated-files-$(CONFIG_SOFTMMU) += $(KEYCODEMAP_FILES)

ui/input-keymap-%.c: $(KEYCODEMAP_GEN) $(KEYCODEMAP_CSV) $(SRC_PATH)/ui/Makefile.objs
	$(call quiet-command,\
	    stem=$* && src=$${stem%-to-*} dst=$${stem#*-to-} && \
	    test -e $(KEYCODEMAP_GEN) && \
	    $(PYTHON) $(KEYCODEMAP_GEN) \
	          --lang glib2 \
	          --varname qemu_input_map_$${src}_to_$${dst} \
	          code-map $(KEYCODEMAP_CSV) $${src} $${dst} \
	        > $@ || rm -f $@, "GEN", "$@")

$(KEYCODEMAP_GEN): .git-submodule-status
$(KEYCODEMAP_CSV): .git-submodule-status

edk2-decompressed = $(basename $(wildcard pc-bios/edk2-*.fd.bz2))
pc-bios/edk2-%.fd: pc-bios/edk2-%.fd.bz2
	$(call quiet-command,bzip2 -d -c $< > $@,"BUNZIP2",$<)

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

.PHONY: all clean cscope distclean html info install install-doc \
	pdf txt recurse-all dist msi FORCE

$(call set-vpath, $(SRC_PATH))

LIBS+=-lz $(LIBS_TOOLS)

vhost-user-json-y =
HELPERS-y =

HELPERS-$(call land,$(CONFIG_SOFTMMU),$(CONFIG_LINUX)) = qemu-bridge-helper$(EXESUF)

ifdef CONFIG_LINUX
ifdef CONFIG_VIRGL
ifdef CONFIG_GBM
HELPERS-y += vhost-user-gpu$(EXESUF)
vhost-user-json-y += contrib/vhost-user-gpu/50-qemu-gpu.json
endif
endif
endif

# Sphinx does not allow building manuals into the same directory as
# the source files, so if we're doing an in-tree QEMU build we must
# build the manuals into a subdirectory (and then install them from
# there for 'make install'). For an out-of-tree build we can just
# use the docs/ subdirectory in the build tree as normal.
ifeq ($(realpath $(SRC_PATH)),$(realpath .))
MANUAL_BUILDDIR := docs/built
else
MANUAL_BUILDDIR := docs
endif

ifdef BUILD_DOCS

=== roms/Makefile ===

vgabios_variants := stdvga cirrus vmware qxl isavga virtio bochs-display ramfb ati
vgabios_targets  := $(subst -isavga,,$(patsubst %,vgabios-%.bin,$(vgabios_variants)))
pxerom_variants  := e1000 e1000e eepro100 ne2k_pci pcnet rtl8139 virtio vmxnet3
pxerom_targets   := 8086100e 808610d3 80861209 10500940 10222000 10ec8139 1af41000 15ad07b0

pxe-rom-e1000    efi-rom-e1000    : VID := 8086
pxe-rom-e1000    efi-rom-e1000    : DID := 100e
pxe-rom-e1000e   efi-rom-e1000e   : VID := 8086
pxe-rom-e1000e   efi-rom-e1000e   : DID := 10d3
pxe-rom-eepro100 efi-rom-eepro100 : VID := 8086
pxe-rom-eepro100 efi-rom-eepro100 : DID := 1209
pxe-rom-ne2k_pci efi-rom-ne2k_pci : VID := 1050
pxe-rom-ne2k_pci efi-rom-ne2k_pci : DID := 0940
pxe-rom-pcnet    efi-rom-pcnet    : VID := 1022
pxe-rom-pcnet    efi-rom-pcnet    : DID := 2000
pxe-rom-rtl8139  efi-rom-rtl8139  : VID := 10ec
pxe-rom-rtl8139  efi-rom-rtl8139  : DID := 8139
pxe-rom-virtio   efi-rom-virtio   : VID := 1af4
pxe-rom-virtio   efi-rom-virtio   : DID := 1000
pxe-rom-vmxnet3  efi-rom-vmxnet3  : VID := 15ad
pxe-rom-vmxnet3  efi-rom-vmxnet3  : DID := 07b0

#
# cross compiler auto detection
#
path := $(subst :, ,$(PATH))
system := $(shell uname -s | tr "A-Z" "a-z")

# first find cross binutils in path
find-cross-ld = $(firstword $(wildcard $(patsubst %,%/$(1)-*$(system)*-ld,$(path))))
# then check we have cross gcc too
find-cross-gcc = $(firstword $(wildcard $(patsubst %ld,%gcc,$(call find-cross-ld,$(1)))))
# finally strip off path + toolname so we get the prefix
find-cross-prefix = $(subst gcc,,$(notdir $(call find-cross-gcc,$(1))))

powerpc64_cross_prefix := $(call find-cross-prefix,powerpc64)
powerpc_cross_prefix := $(call find-cross-prefix,powerpc)
x86_64_cross_prefix := $(call find-cross-prefix,x86_64)
riscv32_cross_prefix := $(call find-cross-prefix,riscv32)
riscv64_cross_prefix := $(call find-cross-prefix,riscv64)

# tag our seabios builds
SEABIOS_EXTRAVERSION="-prebuilt.qemu.org"

#
# EfiRom utility is shipped with edk2 / tianocore, in BaseTools/
#
# We need that to combine multiple images (legacy bios,
# efi ia32, efi x64) into a single rom binary.
#
EDK2_EFIROM = edk2/BaseTools/Source/C/bin/EfiRom

default help:
	@echo "nothing is build by default"
	@echo "available build targets:"
	@echo "  bios               -- update bios.bin (seabios)"
	@echo "  vgabios            -- update vgabios binaries (seabios)"
	@echo "  sgabios            -- update sgabios binaries"
	@echo "  pxerom             -- update nic roms (bios only)"
	@echo "  efirom             -- update nic roms (bios+efi)"
	@echo "  slof               -- update slof.bin"
	@echo "  skiboot            -- update skiboot.lid"
	@echo "  u-boot.e500        -- update u-boot.e500"
	@echo "  u-boot.sam460      -- update u-boot.sam460"
	@echo "  efi                -- update UEFI (edk2) platform firmware"
	@echo "  opensbi32-virt     -- update OpenSBI for 32-bit virt machine"
	@echo "  opensbi64-virt     -- update OpenSBI for 64-bit virt machine"
	@echo "  opensbi64-sifive_u -- update OpenSBI for 64-bit sifive_u machine"
	@echo "  bios-microvm       -- update bios-microvm.bin (qboot)"
	@echo "  clean              -- delete the files generated by the previous" \
	                              "build targets"

bios: build-seabios-config-seabios-128k build-seabios-config-seabios-256k
	cp seabios/builds/seabios-128k/bios.bin ../pc-bios/bios.bin
	cp seabios/builds/seabios-256k/bios.bin ../pc-bios/bios-256k.bin

vgabios seavgabios: $(patsubst %,seavgabios-%,$(vgabios_variants))

seavgabios-isavga: build-seabios-config-vga-isavga
	cp seabios/builds/vga-isavga/vgabios.bin ../pc-bios/vgabios.bin

seavgabios-%: build-seabios-config-vga-%
	cp seabios/builds/vga-$*/vgabios.bin ../pc-bios/vgabios-$*.bin

build-seabios-config-%: config.%
	mkdir -p seabios/builds/$*
	cp $< seabios/builds/$*/.config
	$(MAKE) -C seabios \
		EXTRAVERSION=$(SEABIOS_EXTRAVERSION) \
		CROSS_PREFIX=$(x86_64_cross_prefix) \
		KCONFIG_CONFIG=$(CURDIR)/seabios/builds/$*/.config \
		OUT=$(CURDIR)/seabios/builds/$*/ oldnoconfig
	$(MAKE) -C seabios \
		EXTRAVERSION=$(SEABIOS_EXTRAVERSION) \
		CROSS_PREFIX=$(x86_64_cross_prefix) \
		KCONFIG_CONFIG=$(CURDIR)/seabios/builds/$*/.config \
		OUT=$(CURDIR)/seabios/builds/$*/ all


.PHONY: sgabios skiboot
sgabios:
	$(MAKE) -C sgabios
	cp sgabios/sgabios.bin ../pc-bios


pxerom: $(patsubst %,pxe-rom-%,$(pxerom_variants))

pxe-rom-%: build-pxe-roms
	cp ipxe/src/bin/$(VID)$(DID).rom ../pc-bios/pxe-$*.rom

efirom: $(patsubst %,efi-rom-%,$(pxerom_variants))

efi-rom-%: build-pxe-roms build-efi-roms edk2-basetools
	$(EDK2_EFIROM) -f "0x$(VID)" -i "0x$(DID)" -l 0x02 \
		-b ipxe/src/bin/$(VID)$(DID).rom \
		-ec ipxe/src/bin-i386-efi/$(VID)$(DID).efidrv \
		-ec ipxe/src/bin-x86_64-efi/$(VID)$(DID).efidrv \
		-o ../pc-bios/efi-$*.rom

build-pxe-roms:
	$(MAKE) -C ipxe/src CONFIG=qemu \
		CROSS_COMPILE=$(x86_64_cross_prefix) \
		$(patsubst %,bin/%.rom,$(pxerom_targets))

build-efi-roms: build-pxe-roms
	$(MAKE) -C ipxe/src CONFIG=qemu \
		CROSS_COMPILE=$(x86_64_cross_prefix) \
		$(patsubst %,bin-i386-efi/%.efidrv,$(pxerom_targets)) \
		$(patsubst %,bin-x86_64-efi/%.efidrv,$(pxerom_targets))

# Build scripts can pass compiler/linker flags to the EDK2
# build tools via the EDK2_BASETOOLS_OPTFLAGS (CFLAGS) and
# EDK2_BASETOOLS_LDFLAGS (LDFLAGS) environment variables.
#
# Example:
#
#  make -C roms \
#    EDK2_BASETOOLS_OPTFLAGS='...' \
#    EDK2_BASETOOLS_LDFLAGS='...' \
#    efirom
#
edk2-basetools:
	$(MAKE) -C edk2/BaseTools \
		PYTHON_COMMAND=$${EDK2_PYTHON_COMMAND:-python3} \
		EXTRA_OPTFLAGS='$(EDK2_BASETOOLS_OPTFLAGS)' \
		EXTRA_LDFLAGS='$(EDK2_BASETOOLS_LDFLAGS)'

slof:
	$(MAKE) -C SLOF CROSS=$(powerpc64_cross_prefix) qemu
	cp SLOF/boot_rom.bin ../pc-bios/slof.bin

u-boot.e500:
	$(MAKE) -C u-boot O=build.e500 qemu-ppce500_config
	$(MAKE) -C u-boot CROSS_COMPILE=$(powerpc_cross_prefix) \
		O=build.e500
	$(powerpc_cross_prefix)strip u-boot/build.e500/u-boot -o \
		../pc-bios/u-boot.e500

u-boot.sam460:
	$(MAKE) -C u-boot-sam460ex Sam460ex_config
	$(MAKE) -C u-boot-sam460ex CROSS_COMPILE=$(powerpc_cross_prefix)
	cp u-boot-sam460ex/u-boot.bin ../pc-bios/u-boot-sam460-20100605.bin

skiboot:
	$(MAKE) -C skiboot CROSS=$(powerpc64_cross_prefix)
	cp skiboot/skiboot.lid ../pc-bios/skiboot.lid

efi: edk2-basetools
	$(MAKE) -f Makefile.edk2

opensbi32-virt:
	$(MAKE) -C opensbi \
		CROSS_COMPILE=$(riscv32_cross_prefix) \
		PLATFORM="qemu/virt"
	cp opensbi/build/platform/qemu/virt/firmware/fw_jump.bin ../pc-bios/opensbi-riscv32-virt-fw_jump.bin

opensbi64-virt:
	$(MAKE) -C opensbi \
		CROSS_COMPILE=$(riscv64_cross_prefix) \
		PLATFORM="qemu/virt"
	cp opensbi/build/platform/qemu/virt/firmware/fw_jump.bin ../pc-bios/opensbi-riscv64-virt-fw_jump.bin

opensbi64-sifive_u:
	$(MAKE) -C opensbi \
		CROSS_COMPILE=$(riscv64_cross_prefix) \
		PLATFORM="sifive/fu540"
	cp opensbi/build/platform/sifive/fu540/firmware/fw_jump.bin ../pc-bios/opensbi-riscv64-sifive_u-fw_jump.bin

bios-microvm:
	$(MAKE) -C qboot
	cp qboot/bios.bin ../pc-bios/bios-microvm.bin

clean:
	rm -rf seabios/.config seabios/out seabios/builds
	$(MAKE) -C sgabios clean
	rm -f sgabios/.depend
	$(MAKE) -C ipxe/src veryclean
	$(MAKE) -C edk2/BaseTools clean
	$(MAKE) -C SLOF clean
	rm -rf u-boot/build.e500
	$(MAKE) -C u-boot-sam460ex distclean
	$(MAKE) -C skiboot clean
	$(MAKE) -f Makefile.edk2 clean
	$(MAKE) -C opensbi clean
	$(MAKE) -C qboot clean

=== slirp/Makefile ===
ROOT_DIR := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
BUILD_DIR ?= .

LIBSLIRP = $(BUILD_DIR)/libslirp.a
SLIRP_MAJOR_VERSION = 4
SLIRP_MINOR_VERSION = 0
SLIRP_MICRO_VERSION = 0

all: $(LIBSLIRP)

SRCS := $(wildcard src/*.c)
OBJS := $(SRCS:%.c=$(BUILD_DIR)/%.o)
DEPS := $(OBJS:%.o=%.d)

INC_DIRS := $(BUILD_DIR)/src
INC_FLAGS := $(addprefix -I,$(INC_DIRS))

override CFLAGS +=					\
	-DG_LOG_DOMAIN='"Slirp"'			\
	$(shell $(PKG_CONFIG) --cflags glib-2.0)	\
	$(INC_FLAGS)					\
	-MMD -MP
override LDFLAGS += $(shell $(PKG_CONFIG) --libs glib-2.0)

$(BUILD_DIR)/src/libslirp-version.h:
	@$(MKDIR_P) $(dir $@)
	$(call quiet-command,cat $(ROOT_DIR)/src/libslirp-version.h.in | \
		sed 's/@SLIRP_MAJOR_VERSION@/$(SLIRP_MAJOR_VERSION)/' | \
		sed 's/@SLIRP_MINOR_VERSION@/$(SLIRP_MINOR_VERSION)/' | \
		sed 's/@SLIRP_MICRO_VERSION@/$(SLIRP_MICRO_VERSION)/' \
	> $@,"GEN","$@")

$(OBJS): $(BUILD_DIR)/src/libslirp-version.h

$(LIBSLIRP): $(OBJS)

.PHONY: clean

clean:
	rm -r $(OBJS) $(DEPS) $(LIBSLIRP) $(BUILD_DIR)/src/libslirp-version.h

$(BUILD_DIR)/src/%.o: $(ROOT_DIR)/src/%.c
	@$(MKDIR_P) $(dir $@)
	$(call quiet-command,$(CC) $(CFLAGS) -c -o $@ $<,"CC","$@")

%.a:
	$(call quiet-command,rm -f $@ && $(AR) rcs $@ $^,"AR","$@")

PKG_CONFIG ?= pkg-config
MKDIR_P ?= mkdir -p
quiet-command-run = $(if $(V),,$(if $2,printf "  %-7s %s\n" $2 $3 && ))$1
quiet-@ = $(if $(V),,@)
quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)

print-%:
	@echo '$*=$($*)'

.SUFFIXES:

-include $(DEPS)

=== capstone/bindings/Makefile ===
TMPDIR = /tmp/capstone_test

DIFF = diff -u -w

TEST = $(TMPDIR)/test
TEST_ARM = $(TMPDIR)/test_arm
TEST_ARM64 = $(TMPDIR)/test_arm64
TEST_MIPS = $(TMPDIR)/test_mips
TEST_PPC = $(TMPDIR)/test_ppc
TEST_SPARC = $(TMPDIR)/test_sparc
TEST_SYSZ = $(TMPDIR)/test_systemz
TEST_X86 = $(TMPDIR)/test_x86
TEST_XCORE = $(TMPDIR)/test_xcore

.PHONY: all expected python java ocaml

all:
	cd python && $(MAKE) gen_const
	cd java && $(MAKE) gen_const
	cd ocaml && $(MAKE) gen_const

tests: expected python java #oclma ruby

test_java: expected java
test_python: expected python

expected:
	cd ../tests && $(MAKE)
	mkdir -p $(TMPDIR)
	../tests/test > $(TEST)_e
	../tests/test_arm > $(TEST_ARM)_e
	../tests/test_arm64 > $(TEST_ARM64)_e
	../tests/test_mips > $(TEST_MIPS)_e
	../tests/test_ppc > $(TEST_PPC)_e
	../tests/test_sparc > $(TEST_SPARC)_e
	../tests/test_systemz > $(TEST_SYSZ)_e
	../tests/test_x86 > $(TEST_X86)_e
	../tests/test_xcore > $(TEST_XCORE)_e

python: FORCE
	cd python && $(MAKE)
	python python/test.py > $(TEST)_o
	python python/test_arm.py > $(TEST_ARM)_o
	python python/test_arm64.py > $(TEST_ARM64)_o
	python python/test_mips.py > $(TEST_MIPS)_o
	python python/test_ppc.py > $(TEST_PPC)_o
	python python/test_sparc.py > $(TEST_SPARC)_o
	python python/test_systemz.py > $(TEST_SYSZ)_o
	python python/test_x86.py > $(TEST_X86)_o
	python python/test_xcore.py > $(TEST_XCORE)_o
	$(MAKE) test_diff

java: FORCE
	cd java && $(MAKE)
	cd java && ./run.sh > $(TEST)_o
	cd java && ./run.sh arm > $(TEST_ARM)_o
	cd java && ./run.sh arm64 > $(TEST_ARM64)_o
	cd java && ./run.sh mips > $(TEST_MIPS)_o
	cd java && ./run.sh ppc > $(TEST_PPC)_o
	cd java && ./run.sh sparc > $(TEST_SPARC)_o
	cd java && ./run.sh systemz > $(TEST_SYSZ)_o
	cd java && ./run.sh x86 > $(TEST_X86)_o
	cd java && ./run.sh xcore > $(TEST_XCORE)_o
	$(MAKE) test_diff

ocaml: FORCE

test_diff: FORCE
	$(DIFF) $(TEST)_e $(TEST)_o
	$(DIFF) $(TEST_ARM)_e $(TEST_ARM)_o
	$(DIFF) $(TEST_ARM64)_e $(TEST_ARM64)_o
	$(DIFF) $(TEST_MIPS)_e $(TEST_MIPS)_o
	$(DIFF) $(TEST_PPC)_e $(TEST_PPC)_o
	$(DIFF) $(TEST_SPARC)_e $(TEST_SPARC)_o
	$(DIFF) $(TEST_SYSZ)_e $(TEST_SYSZ)_o
	$(DIFF) $(TEST_X86)_e $(TEST_X86)_o
	$(DIFF) $(TEST_XCORE)_e $(TEST_XCORE)_o

clean:
	rm -rf $(TMPDIR)
	cd java && $(MAKE) clean
	cd python && $(MAKE) clean
	cd ocaml && $(MAKE) clean

check:
	make -C ocaml check
	make -C python check
	make -C java check

FORCE:

=== pc-bios/keymaps/Makefile ===

KEYMAP	:= $(shell which qemu-keymap 2>/dev/null)

MAPS	:= ar bepo cz da de de-ch en-us en-gb es et fi fo \
	   fr fr-be fr-ca fr-ch \
	   hr hu is it ja lt lv mk nl no pl pt pt-br ru th tr

ar	: MAP_FLAGS :=	-l ar
bepo	: MAP_FLAGS :=	-l fr -v dvorak
cz	: MAP_FLAGS :=	-l cz
da	: MAP_FLAGS :=	-l dk
de	: MAP_FLAGS :=	-l de -v nodeadkeys
de-ch	: MAP_FLAGS :=	-l ch
en-us	: MAP_FLAGS :=	-l us
en-gb	: MAP_FLAGS :=	-l gb
es	: MAP_FLAGS :=	-l es
et	: MAP_FLAGS :=	-l et
fi	: MAP_FLAGS :=	-l fi
fo	: MAP_FLAGS :=	-l fo
fr	: MAP_FLAGS :=	-l fr -v nodeadkeys
fr-be	: MAP_FLAGS :=	-l be
fr-ca	: MAP_FLAGS :=	-l ca -v fr
fr-ch	: MAP_FLAGS :=	-l ch -v fr
hr	: MAP_FLAGS :=	-l hr
hu	: MAP_FLAGS :=	-l hu
is	: MAP_FLAGS :=	-l is
it	: MAP_FLAGS :=	-l it
ja	: MAP_FLAGS :=	-l jp -m jp106
lt	: MAP_FLAGS :=	-l lt
lv	: MAP_FLAGS :=	-l lv
mk	: MAP_FLAGS :=	-l mk
nl	: MAP_FLAGS :=	-l nl
no	: MAP_FLAGS :=	-l no
pl	: MAP_FLAGS :=	-l pl
pt	: MAP_FLAGS :=	-l pt
pt-br	: MAP_FLAGS :=	-l br
ru	: MAP_FLAGS :=	-l ru
th	: MAP_FLAGS :=	-l th
tr	: MAP_FLAGS :=	-l tr

ifeq ($(KEYMAP),)

all:
	@echo "nothing to do (qemu-keymap not found)"

else

all: $(MAPS)

clean:
	rm -f $(MAPS)

$(MAPS): $(KEYMAP) Makefile
	$(KEYMAP) -f $@ $(MAP_FLAGS)

endif

=== roms/sgabios/Makefile ===
# Copyright 2010 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# $Id$

BUILD_DATE = \"$(shell date -u)\"
BUILD_SHORT_DATE = \"$(shell date -u +%D)\"
BUILD_HOST = \"$(shell hostname)\"
BUILD_USER = \"$(shell whoami)\"

CFLAGS := -Wall -Os -m32 -nostdlib

ASFLAGS := $(CFLAGS)
ASFLAGS += -DBUILD_DATE="$(BUILD_DATE)"
ASFLAGS += -DBUILD_SHORT_DATE="$(BUILD_SHORT_DATE)"
ASFLAGS += -DBUILD_HOST="$(BUILD_HOST)"
ASFLAGS += -DBUILD_USER="$(BUILD_USER)"

LDSCRIPT := rom16.ld
LDFLAGS := -T $(LDSCRIPT) -nostdlib
OBJCOPY := objcopy

ASRCS = sgabios.S

CSRCS =

SRCS = $(CSRCS) $(ASRCS)

OBJS = ${CSRCS:.c=.o} ${ASRCS:.S=.o}
INCS = ${CSRCS:.c=.h} ${ASRCS:.S=.h}

PROGS = sgabios.bin csum8

.SUFFIXES: .bin .elf
.PHONY: buildinfo

all: $(PROGS)

sgabios.bin: sgabios.elf
	$(OBJCOPY) -O binary $< $@
	./csum8 $@

sgabios.elf: .depend $(OBJS) $(LDSCRIPT) csum8
	$(LD) $(LDFLAGS) $(OBJS) -o $@

csum8: csum8.c
	$(CC) -Wall -O2 -o $@ $<

sgabios.o: buildinfo


buildinfo:
	touch sgabios.S
clean:
	$(RM) $(PROGS) $(OBJS) *.elf *.srec *.com version.h

.depend:: $(INCS) $(SRCS) Makefile
	$(RM) .depend
	$(CPP) -M $(CFLAGS) $(SRCS) >.tmpdepend && mv .tmpdepend .depend

ifeq (.depend, $(wildcard .depend))
include .depend
else
# if no .depend file existed, add a make clean to the end of building .depend
.depend::
	$(MAKE) clean
endif

=== tests/fp/Makefile ===
BUILD_DIR := $(CURDIR)/../..

include $(BUILD_DIR)/config-host.mak
include $(SRC_PATH)/rules.mak

SOFTFLOAT_DIR := $(SRC_PATH)/tests/fp/berkeley-softfloat-3
TESTFLOAT_DIR := $(SRC_PATH)/tests/fp/berkeley-testfloat-3

SF_SOURCE_DIR  := $(SOFTFLOAT_DIR)/source
SF_INCLUDE_DIR := $(SOFTFLOAT_DIR)/source/include
# we could use any specialize here, it doesn't matter
SF_SPECIALIZE := 8086-SSE
SF_SPECIALIZE_DIR := $(SF_SOURCE_DIR)/$(SF_SPECIALIZE)

TF_SOURCE_DIR := $(TESTFLOAT_DIR)/source

$(call set-vpath, $(SRC_PATH)/fpu $(SRC_PATH)/tests/fp)

LIBQEMUUTIL := $(BUILD_DIR)/libqemuutil.a

# Use this variable to be clear when we pull in our own implementation
# We build the object with a default rule thanks to the vpath above
QEMU_SOFTFLOAT_OBJ := softfloat.o

QEMU_INCLUDES += -I$(SRC_PATH)/tests/fp
QEMU_INCLUDES += -I$(SF_INCLUDE_DIR)
QEMU_INCLUDES += -I$(SF_SPECIALIZE_DIR)
QEMU_INCLUDES += -I$(TF_SOURCE_DIR)

# work around TARGET_* poisoning
QEMU_CFLAGS += -DHW_POISON_H
# define a target to match testfloat's implementation-defined choices, such as
# whether to raise the invalid flag when dealing with NaNs in muladd.
QEMU_CFLAGS += -DTARGET_ARM

# capstone has a platform.h file that clashes with softfloat's
QEMU_CFLAGS := $(filter-out %capstone, $(QEMU_CFLAGS))

# softfloat defines
SF_OPTS :=
SF_OPTS += -DSOFTFLOAT_ROUND_ODD
SF_OPTS += -DINLINE_LEVEL=5
SF_OPTS += -DSOFTFLOAT_FAST_DIV32TO16
SF_OPTS += -DSOFTFLOAT_FAST_DIV64TO32
SF_OPTS += -DSOFTFLOAT_FAST_INT64
QEMU_CFLAGS += $(SF_OPTS)

# silence the build of softfloat objects
SF_CFLAGS += -Wno-missing-prototypes
SF_CFLAGS += -Wno-redundant-decls
SF_CFLAGS += -Wno-return-type
SF_CFLAGS += -Wno-error

# testfloat defines
TF_OPTS :=
TF_OPTS += -DFLOAT16
TF_OPTS += -DFLOAT64
TF_OPTS += -DEXTFLOAT80
TF_OPTS += -DFLOAT128
TF_OPTS += -DFLOAT_ROUND_ODD
TF_OPTS += -DLONG_DOUBLE_IS_EXTFLOAT80
QEMU_CFLAGS += $(TF_OPTS)

# silence the build of testfloat objects
TF_CFLAGS :=
TF_CFLAGS += -Wno-strict-prototypes
TF_CFLAGS += -Wno-unknown-pragmas
TF_CFLAGS += -Wno-uninitialized
TF_CFLAGS += -Wno-missing-prototypes
TF_CFLAGS += -Wno-return-type
TF_CFLAGS += -Wno-unused-function
TF_CFLAGS += -Wno-error

# softfloat objects
SF_OBJS_PRIMITIVES :=
SF_OBJS_PRIMITIVES += s_eq128.o
SF_OBJS_PRIMITIVES += s_le128.o
SF_OBJS_PRIMITIVES += s_lt128.o
SF_OBJS_PRIMITIVES += s_shortShiftLeft128.o
SF_OBJS_PRIMITIVES += s_shortShiftRight128.o
SF_OBJS_PRIMITIVES += s_shortShiftRightJam64.o
SF_OBJS_PRIMITIVES += s_shortShiftRightJam64Extra.o
SF_OBJS_PRIMITIVES += s_shortShiftRightJam128.o
SF_OBJS_PRIMITIVES += s_shortShiftRightJam128Extra.o
SF_OBJS_PRIMITIVES += s_shiftRightJam32.o
SF_OBJS_PRIMITIVES += s_shiftRightJam64.o
SF_OBJS_PRIMITIVES += s_shiftRightJam64Extra.o
SF_OBJS_PRIMITIVES += s_shiftRightJam128.o
SF_OBJS_PRIMITIVES += s_shiftRightJam128Extra.o
SF_OBJS_PRIMITIVES += s_shiftRightJam256M.o
SF_OBJS_PRIMITIVES += s_countLeadingZeros8.o
SF_OBJS_PRIMITIVES += s_countLeadingZeros16.o
SF_OBJS_PRIMITIVES += s_countLeadingZeros32.o
SF_OBJS_PRIMITIVES += s_countLeadingZeros64.o
SF_OBJS_PRIMITIVES += s_add128.o
SF_OBJS_PRIMITIVES += s_add256M.o
SF_OBJS_PRIMITIVES += s_sub128.o
SF_OBJS_PRIMITIVES += s_sub256M.o
SF_OBJS_PRIMITIVES += s_mul64ByShifted32To128.o
SF_OBJS_PRIMITIVES += s_mul64To128.o
SF_OBJS_PRIMITIVES += s_mul128By32.o
SF_OBJS_PRIMITIVES += s_mul128To256M.o
SF_OBJS_PRIMITIVES += s_approxRecip_1Ks.o
SF_OBJS_PRIMITIVES += s_approxRecip32_1.o
SF_OBJS_PRIMITIVES += s_approxRecipSqrt_1Ks.o
SF_OBJS_PRIMITIVES += s_approxRecipSqrt32_1.o

SF_OBJS_SPECIALIZE :=
SF_OBJS_SPECIALIZE += softfloat_raiseFlags.o
SF_OBJS_SPECIALIZE += s_f16UIToCommonNaN.o
SF_OBJS_SPECIALIZE += s_commonNaNToF16UI.o
SF_OBJS_SPECIALIZE += s_propagateNaNF16UI.o
SF_OBJS_SPECIALIZE += s_f32UIToCommonNaN.o
SF_OBJS_SPECIALIZE += s_commonNaNToF32UI.o
SF_OBJS_SPECIALIZE += s_propagateNaNF32UI.o
SF_OBJS_SPECIALIZE += s_f64UIToCommonNaN.o
SF_OBJS_SPECIALIZE += s_commonNaNToF64UI.o
SF_OBJS_SPECIALIZE += s_propagateNaNF64UI.o
SF_OBJS_SPECIALIZE += extF80M_isSignalingNaN.o
SF_OBJS_SPECIALIZE += s_extF80UIToCommonNaN.o
SF_OBJS_SPECIALIZE += s_commonNaNToExtF80UI.o
SF_OBJS_SPECIALIZE += s_propagateNaNExtF80UI.o
SF_OBJS_SPECIALIZE += f128M_isSignalingNaN.o
SF_OBJS_SPECIALIZE += s_f128UIToCommonNaN.o
SF_OBJS_SPECIALIZE += s_commonNaNToF128UI.o
SF_OBJS_SPECIALIZE += s_propagateNaNF128UI.o

SF_OBJS_OTHERS :=
SF_OBJS_OTHERS += s_roundToUI32.o
SF_OBJS_OTHERS += s_roundToUI64.o
SF_OBJS_OTHERS += s_roundToI32.o
SF_OBJS_OTHERS += s_roundToI64.o
SF_OBJS_OTHERS += s_normSubnormalF16Sig.o
SF_OBJS_OTHERS += s_roundPackToF16.o
SF_OBJS_OTHERS += s_normRoundPackToF16.o
SF_OBJS_OTHERS += s_addMagsF16.o
SF_OBJS_OTHERS += s_subMagsF16.o
SF_OBJS_OTHERS += s_mulAddF16.o
SF_OBJS_OTHERS += s_normSubnormalF32Sig.o
SF_OBJS_OTHERS += s_roundPackToF32.o
SF_OBJS_OTHERS += s_normRoundPackToF32.o
SF_OBJS_OTHERS += s_addMagsF32.o
SF_OBJS_OTHERS += s_subMagsF32.o
SF_OBJS_OTHERS += s_mulAddF32.o
SF_OBJS_OTHERS += s_normSubnormalF64Sig.o
SF_OBJS_OTHERS += s_roundPackToF64.o
SF_OBJS_OTHERS += s_normRoundPackToF64.o
SF_OBJS_OTHERS += s_addMagsF64.o
SF_OBJS_OTHERS += s_subMagsF64.o
SF_OBJS_OTHERS += s_mulAddF64.o
SF_OBJS_OTHERS += s_normSubnormalExtF80Sig.o
SF_OBJS_OTHERS += s_roundPackToExtF80.o
SF_OBJS_OTHERS += s_normRoundPackToExtF80.o
SF_OBJS_OTHERS += s_addMagsExtF80.o
SF_OBJS_OTHERS += s_subMagsExtF80.o
SF_OBJS_OTHERS += s_normSubnormalF128Sig.o
SF_OBJS_OTHERS += s_roundPackToF128.o
SF_OBJS_OTHERS += s_normRoundPackToF128.o
SF_OBJS_OTHERS += s_addMagsF128.o
SF_OBJS_OTHERS += s_subMagsF128.o
SF_OBJS_OTHERS += s_mulAddF128.o
SF_OBJS_OTHERS += softfloat_state.o
SF_OBJS_OTHERS += ui32_to_f16.o
SF_OBJS_OTHERS += ui32_to_f32.o
SF_OBJS_OTHERS += ui32_to_f64.o
SF_OBJS_OTHERS += ui32_to_extF80.o
SF_OBJS_OTHERS += ui32_to_extF80M.o
SF_OBJS_OTHERS += ui32_to_f128.o
SF_OBJS_OTHERS += ui32_to_f128M.o
SF_OBJS_OTHERS += ui64_to_f16.o
SF_OBJS_OTHERS += ui64_to_f32.o
SF_OBJS_OTHERS += ui64_to_f64.o
SF_OBJS_OTHERS += ui64_to_extF80.o
SF_OBJS_OTHERS += ui64_to_extF80M.o
SF_OBJS_OTHERS += ui64_to_f128.o
SF_OBJS_OTHERS += ui64_to_f128M.o
SF_OBJS_OTHERS += i32_to_f16.o
SF_OBJS_OTHERS += i32_to_f32.o
SF_OBJS_OTHERS += i32_to_f64.o
SF_OBJS_OTHERS += i32_to_extF80.o
SF_OBJS_OTHERS += i32_to_extF80M.o
SF_OBJS_OTHERS += i32_to_f128.o
SF_OBJS_OTHERS += i32_to_f128M.o
SF_OBJS_OTHERS += i64_to_f16.o
SF_OBJS_OTHERS += i64_to_f32.o
SF_OBJS_OTHERS += i64_to_f64.o
SF_OBJS_OTHERS += i64_to_extF80.o
SF_OBJS_OTHERS += i64_to_extF80M.o
SF_OBJS_OTHERS += i64_to_f128.o
SF_OBJS_OTHERS += i64_to_f128M.o
SF_OBJS_OTHERS += f16_to_ui32.o
SF_OBJS_OTHERS += f16_to_ui64.o
SF_OBJS_OTHERS += f16_to_i32.o
SF_OBJS_OTHERS += f16_to_i64.o
SF_OBJS_OTHERS += f16_to_ui32_r_minMag.o
SF_OBJS_OTHERS += f16_to_ui64_r_minMag.o
SF_OBJS_OTHERS += f16_to_i32_r_minMag.o
SF_OBJS_OTHERS += f16_to_i64_r_minMag.o
SF_OBJS_OTHERS += f16_to_f32.o
SF_OBJS_OTHERS += f16_to_f64.o
SF_OBJS_OTHERS += f16_to_extF80.o
SF_OBJS_OTHERS += f16_to_extF80M.o
SF_OBJS_OTHERS += f16_to_f128.o
SF_OBJS_OTHERS += f16_to_f128M.o
SF_OBJS_OTHERS += f16_roundToInt.o
SF_OBJS_OTHERS += f16_add.o
SF_OBJS_OTHERS += f16_sub.o
SF_OBJS_OTHERS += f16_mul.o
SF_OBJS_OTHERS += f16_mulAdd.o
SF_OBJS_OTHERS += f16_div.o
SF_OBJS_OTHERS += f16_rem.o
SF_OBJS_OTHERS += f16_sqrt.o
SF_OBJS_OTHERS += f16_eq.o
SF_OBJS_OTHERS += f16_le.o
SF_OBJS_OTHERS += f16_lt.o
SF_OBJS_OTHERS += f16_eq_signaling.o
SF_OBJS_OTHERS += f16_le_quiet.o
SF_OBJS_OTHERS += f16_lt_quiet.o
SF_OBJS_OTHERS += f16_isSignalingNaN.o
SF_OBJS_OTHERS += f32_to_ui32.o
SF_OBJS_OTHERS += f32_to_ui64.o
SF_OBJS_OTHERS += f32_to_i32.o
SF_OBJS_OTHERS += f32_to_i64.o
SF_OBJS_OTHERS += f32_to_ui32_r_minMag.o
SF_OBJS_OTHERS += f32_to_ui64_r_minMag.o
SF_OBJS_OTHERS += f32_to_i32_r_minMag.o
SF_OBJS_OTHERS += f32_to_i64_r_minMag.o
SF_OBJS_OTHERS += f32_to_f16.o
SF_OBJS_OTHERS += f32_to_f64.o
SF_OBJS_OTHERS += f32_to_extF80.o
SF_OBJS_OTHERS += f32_to_extF80M.o
SF_OBJS_OTHERS += f32_to_f128.o
SF_OBJS_OTHERS += f32_to_f128M.o
SF_OBJS_OTHERS += f32_roundToInt.o
SF_OBJS_OTHERS += f32_add.o
SF_OBJS_OTHERS += f32_sub.o
SF_OBJS_OTHERS += f32_mul.o
SF_OBJS_OTHERS += f32_mulAdd.o
SF_OBJS_OTHERS += f32_div.o
SF_OBJS_OTHERS += f32_rem.o
SF_OBJS_OTHERS += f32_sqrt.o
SF_OBJS_OTHERS += f32_eq.o
SF_OBJS_OTHERS += f32_le.o
SF_OBJS_OTHERS += f32_lt.o
SF_OBJS_OTHERS += f32_eq_signaling.o
SF_OBJS_OTHERS += f32_le_quiet.o
SF_OBJS_OTHERS += f32_lt_quiet.o
SF_OBJS_OTHERS += f32_isSignalingNaN.o
SF_OBJS_OTHERS += f64_to_ui32.o
SF_OBJS_OTHERS += f64_to_ui64.o
SF_OBJS_OTHERS += f64_to_i32.o
SF_OBJS_OTHERS += f64_to_i64.o
SF_OBJS_OTHERS += f64_to_ui32_r_minMag.o
SF_OBJS_OTHERS += f64_to_ui64_r_minMag.o
SF_OBJS_OTHERS += f64_to_i32_r_minMag.o
SF_OBJS_OTHERS += f64_to_i64_r_minMag.o
SF_OBJS_OTHERS += f64_to_f16.o
SF_OBJS_OTHERS += f64_to_f32.o
SF_OBJS_OTHERS += f64_to_extF80.o
SF_OBJS_OTHERS += f64_to_extF80M.o
SF_OBJS_OTHERS += f64_to_f128.o
SF_OBJS_OTHERS += f64_to_f128M.o
SF_OBJS_OTHERS += f64_roundToInt.o
SF_OBJS_OTHERS += f64_add.o
SF_OBJS_OTHERS += f64_sub.o
SF_OBJS_OTHERS += f64_mul.o
SF_OBJS_OTHERS += f64_mulAdd.o
SF_OBJS_OTHERS += f64_div.o
SF_OBJS_OTHERS += f64_rem.o
SF_OBJS_OTHERS += f64_sqrt.o
SF_OBJS_OTHERS += f64_eq.o
SF_OBJS_OTHERS += f64_le.o
SF_OBJS_OTHERS += f64_lt.o
SF_OBJS_OTHERS += f64_eq_signaling.o
SF_OBJS_OTHERS += f64_le_quiet.o
SF_OBJS_OTHERS += f64_lt_quiet.o
SF_OBJS_OTHERS += f64_isSignalingNaN.o
SF_OBJS_OTHERS += extF80_to_ui32.o
SF_OBJS_OTHERS += extF80_to_ui64.o
SF_OBJS_OTHERS += extF80_to_i32.o
SF_OBJS_OTHERS += extF80_to_i64.o
SF_OBJS_OTHERS += extF80_to_ui32_r_minMag.o
SF_OBJS_OTHERS += extF80_to_ui64_r_minMag.o
SF_OBJS_OTHERS += extF80_to_i32_r_minMag.o
SF_OBJS_OTHERS += extF80_to_i64_r_minMag.o
SF_OBJS_OTHERS += extF80_to_f16.o
SF_OBJS_OTHERS += extF80_to_f32.o
SF_OBJS_OTHERS += extF80_to_f64.o
SF_OBJS_OTHERS += extF80_to_f128.o
SF_OBJS_OTHERS += extF80_roundToInt.o
SF_OBJS_OTHERS += extF80_add.o
SF_OBJS_OTHERS += extF80_sub.o
SF_OBJS_OTHERS += extF80_mul.o
SF_OBJS_OTHERS += extF80_div.o
SF_OBJS_OTHERS += extF80_rem.o
SF_OBJS_OTHERS += extF80_sqrt.o
SF_OBJS_OTHERS += extF80_eq.o
SF_OBJS_OTHERS += extF80_le.o
SF_OBJS_OTHERS += extF80_lt.o
SF_OBJS_OTHERS += extF80_eq_signaling.o
SF_OBJS_OTHERS += extF80_le_quiet.o
SF_OBJS_OTHERS += extF80_lt_quiet.o
SF_OBJS_OTHERS += extF80_isSignalingNaN.o
SF_OBJS_OTHERS += extF80M_to_ui32.o
SF_OBJS_OTHERS += extF80M_to_ui64.o
SF_OBJS_OTHERS += extF80M_to_i32.o
SF_OBJS_OTHERS += extF80M_to_i64.o
SF_OBJS_OTHERS += extF80M_to_ui32_r_minMag.o
SF_OBJS_OTHERS += extF80M_to_ui64_r_minMag.o
SF_OBJS_OTHERS += extF80M_to_i32_r_minMag.o
SF_OBJS_OTHERS += extF80M_to_i64_r_minMag.o
SF_OBJS_OTHERS += extF80M_to_f16.o
SF_OBJS_OTHERS += extF80M_to_f32.o
SF_OBJS_OTHERS += extF80M_to_f64.o
SF_OBJS_OTHERS += extF80M_to_f128M.o
SF_OBJS_OTHERS += extF80M_roundToInt.o
SF_OBJS_OTHERS += extF80M_add.o
SF_OBJS_OTHERS += extF80M_sub.o
SF_OBJS_OTHERS += extF80M_mul.o
SF_OBJS_OTHERS += extF80M_div.o
SF_OBJS_OTHERS += extF80M_rem.o
SF_OBJS_OTHERS += extF80M_sqrt.o
SF_OBJS_OTHERS += extF80M_eq.o
SF_OBJS_OTHERS += extF80M_le.o
SF_OBJS_OTHERS += extF80M_lt.o
SF_OBJS_OTHERS += extF80M_eq_signaling.o
SF_OBJS_OTHERS += extF80M_le_quiet.o
SF_OBJS_OTHERS += extF80M_lt_quiet.o
SF_OBJS_OTHERS += f128_to_ui32.o
SF_OBJS_OTHERS += f128_to_ui64.o
SF_OBJS_OTHERS += f128_to_i32.o
SF_OBJS_OTHERS += f128_to_i64.o
SF_OBJS_OTHERS += f128_to_ui32_r_minMag.o
SF_OBJS_OTHERS += f128_to_ui64_r_minMag.o
SF_OBJS_OTHERS += f128_to_i32_r_minMag.o
SF_OBJS_OTHERS += f128_to_i64_r_minMag.o
SF_OBJS_OTHERS += f128_to_f16.o
SF_OBJS_OTHERS += f128_to_f32.o
SF_OBJS_OTHERS += f128_to_extF80.o
SF_OBJS_OTHERS += f128_to_f64.o
SF_OBJS_OTHERS += f128_roundToInt.o
SF_OBJS_OTHERS += f128_add.o
SF_OBJS_OTHERS += f128_sub.o
SF_OBJS_OTHERS += f128_mul.o
SF_OBJS_OTHERS += f128_mulAdd.o
SF_OBJS_OTHERS += f128_div.o
SF_OBJS_OTHERS += f128_rem.o
SF_OBJS_OTHERS += f128_sqrt.o
SF_OBJS_OTHERS += f128_eq.o
SF_OBJS_OTHERS += f128_le.o
SF_OBJS_OTHERS += f128_lt.o
SF_OBJS_OTHERS += f128_eq_signaling.o
SF_OBJS_OTHERS += f128_le_quiet.o

=== capstone/bindings/python/Makefile ===
.PHONY: gen_const install install3 install_cython sdist sdist3 bdist bdist3 clean check

gen_const:
	cd .. && python const_generator.py python

install:
	rm -rf src/
	if test -n "${DESTDIR}"; then \
		python setup.py build install --root="${DESTDIR}"; \
	else \
		python setup.py build install; \
	fi

install3:
	rm -rf src/
	if test -n "${DESTDIR}"; then \
		python3 setup.py build install --root="${DESTDIR}"; \
	else \
		python3 setup.py build install; \
	fi

# NOTE: Newer cython can be installed by: sudo pip install --upgrade cython
install_cython:
	rm -rf src/
	if test -n "${DESTDIR}"; then \
		python setup_cython.py build install --root="${DESTDIR}"; \
	else \
		python setup_cython.py build install; \
	fi

install3_cython:
	rm -rf src/
	if test -n "${DESTDIR}"; then \
		python3 setup_cython.py build install --root="${DESTDIR}"; \
	else \
		python3 setup_cython.py build install; \
	fi

# build & upload PyPi package with source code of the core
sdist:
	rm -rf src/ dist/
	python setup.py sdist register upload

# build & upload PyPi package with source code of the core
sdist3:
	rm -rf src/ dist/
	python3 setup.py sdist register upload

# build & upload PyPi package with prebuilt core
bdist:
	rm -rf src/ dist/
	python setup.py bdist_wheel register upload

# build & upload PyPi package with prebuilt core
bdist3:
	rm -rf src/ dist/
	python3 setup.py bdist_wheel register upload

clean:
	rm -rf build/ src/ dist/ *.egg-info
	rm -rf capstone/lib capstone/include pyx/lib pyx/include
	rm -f pyx/*.c pyx/__init__.py
	for f in capstone/*.py; do rm -f pyx/$$(basename $$f)x; done
	rm -f MANIFEST


TESTS = test_basic.py test_detail.py test_arm.py test_arm64.py test_mips.py test_ppc.py
TESTS += test_sparc.py test_systemz.py test_x86.py test_xcore.py test_skipdata.py
check:
	@for t in $(TESTS); do \
		echo Check $$t ... ; \
		./$$t > /dev/null && echo OK || echo FAILED; \
	done

=== capstone/suite/fuzz/Makefile ===
LIBNAME = capstone

fuzz_harness: fuzz_harness.o
	${CC} $< -O3 -Wall -l$(LIBNAME) -o $@

%.o: %.c
	${CC} -c -I../../include $< -o $@

clean:
	rm -rf *.o fuzz_harness

=== roms/u-boot/fs/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2000-2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
# Copyright (c) 2012, NVIDIA CORPORATION.  All rights reserved.

ifdef CONFIG_SPL_BUILD
obj-$(CONFIG_FS_LOADER) += fs.o
obj-$(CONFIG_SPL_FAT_SUPPORT) += fat/
obj-$(CONFIG_SPL_EXT_SUPPORT) += ext4/
else
obj-y				+= fs.o

obj-$(CONFIG_FS_BTRFS) += btrfs/
obj-$(CONFIG_FS_CBFS) += cbfs/
obj-$(CONFIG_CMD_CRAMFS) += cramfs/
obj-$(CONFIG_FS_EXT4) += ext4/
obj-y += fat/
obj-$(CONFIG_FS_JFFS2) += jffs2/
obj-$(CONFIG_CMD_REISER) += reiserfs/
obj-$(CONFIG_SANDBOX) += sandbox/
obj-$(CONFIG_CMD_UBIFS) += ubifs/
obj-$(CONFIG_YAFFS2) += yaffs2/
obj-$(CONFIG_CMD_ZFS) += zfs/
endif
obj-y += fs_internal.o

=== roms/u-boot/tools/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# (C) Copyright 2000-2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.

# Enable all the config-independent tools
ifneq ($(HOST_TOOLS_ALL),)
CONFIG_KIRKWOOD = y
CONFIG_LCD_LOGO = y
CONFIG_CMD_LOADS = y
CONFIG_CMD_NET = y
CONFIG_XWAY_SWAP_BYTES = y
CONFIG_NETCONSOLE = y
CONFIG_SHA1_CHECK_UB_IMG = y
CONFIG_ARCH_SUNXI = y
endif

subdir-$(HOST_TOOLS_ALL) += easylogo
subdir-$(HOST_TOOLS_ALL) += gdb

# Merge all the different vars for envcrc into one
ENVCRC-$(CONFIG_ENV_IS_EMBEDDED) = y
ENVCRC-$(CONFIG_ENV_IS_IN_EEPROM) = y
ENVCRC-$(CONFIG_ENV_IS_IN_FLASH) = y
ENVCRC-$(CONFIG_ENV_IS_IN_ONENAND) = y
ENVCRC-$(CONFIG_ENV_IS_IN_NAND) = y
ENVCRC-$(CONFIG_ENV_IS_IN_NVRAM) = y
ENVCRC-$(CONFIG_ENV_IS_IN_SPI_FLASH) = y
CONFIG_BUILD_ENVCRC ?= $(ENVCRC-y)

hostprogs-$(CONFIG_SPL_GENERATE_ATMEL_PMECC_HEADER) += atmel_pmecc_params

hostprogs-$(CONFIG_LCD_LOGO) += bmp_logo
hostprogs-$(CONFIG_VIDEO_LOGO) += bmp_logo
HOSTCFLAGS_bmp_logo.o := -pedantic

hostprogs-$(CONFIG_BUILD_ENVCRC) += envcrc
envcrc-objs := envcrc.o lib/crc32.o env/embedded.o lib/sha1.o

hostprogs-$(CONFIG_CMD_NET) += gen_eth_addr
HOSTCFLAGS_gen_eth_addr.o := -pedantic

hostprogs-$(CONFIG_CMD_NET) += gen_ethaddr_crc
gen_ethaddr_crc-objs := gen_ethaddr_crc.o lib/crc8.o
HOSTCFLAGS_gen_ethaddr_crc.o := -pedantic

hostprogs-$(CONFIG_CMD_LOADS) += img2srec
HOSTCFLAGS_img2srec.o := -pedantic

hostprogs-$(CONFIG_XWAY_SWAP_BYTES) += xway-swap-bytes
HOSTCFLAGS_xway-swap-bytes.o := -pedantic

hostprogs-y += mkenvimage
mkenvimage-objs := mkenvimage.o os_support.o lib/crc32.o

hostprogs-y += dumpimage mkimage
hostprogs-$(CONFIG_FIT_SIGNATURE) += fit_info fit_check_sign

hostprogs-$(CONFIG_CMD_BOOTEFI_SELFTEST) += file2include

FIT_SIG_OBJS-$(CONFIG_FIT_SIGNATURE) := common/image-sig.o

# The following files are synced with upstream DTC.
# Use synced versions from scripts/dtc/libfdt/.
LIBFDT_SRCS_SYNCED := fdt.c fdt_wip.c fdt_sw.c fdt_rw.c \
		fdt_strerror.c fdt_empty_tree.c fdt_addresses.c fdt_overlay.c
# The following files are locally modified for U-Boot (unfotunately).
# Use U-Boot own versions from lib/libfdt/.
LIBFDT_SRCS_UNSYNCED := fdt_ro.c fdt_region.c

LIBFDT_OBJS := $(addprefix libfdt/, $(patsubst %.c, %.o, $(LIBFDT_SRCS_SYNCED))) \
	       $(addprefix lib/libfdt/, $(patsubst %.c, %.o, $(LIBFDT_SRCS_UNSYNCED)))

RSA_OBJS-$(CONFIG_FIT_SIGNATURE) := $(addprefix lib/rsa/, \
					rsa-sign.o rsa-verify.o rsa-checksum.o \
					rsa-mod-exp.o)

ROCKCHIP_OBS = lib/rc4.o rkcommon.o rkimage.o rksd.o rkspi.o

# common objs for dumpimage and mkimage
dumpimage-mkimage-objs := aisimage.o \
			atmelimage.o \
			$(FIT_SIG_OBJS-y) \
			common/bootm.o \
			lib/crc32.o \
			default_image.o \
			lib/fdtdec_common.o \
			lib/fdtdec.o \
			fit_common.o \
			fit_image.o \
			common/image-fit.o \
			image-host.o \
			common/image.o \
			imagetool.o \
			imximage.o \
			imx8image.o \
			imx8mimage.o \
			kwbimage.o \
			lib/md5.o \
			lpc32xximage.o \
			mxsimage.o \
			omapimage.o \
			os_support.o \
			pblimage.o \
			pbl_crc32.o \
			vybridimage.o \
			stm32image.o \
			$(ROCKCHIP_OBS) \
			socfpgaimage.o \
			lib/crc16.o \
			lib/sha1.o \
			lib/sha256.o \
			common/hash.o \
			ublimage.o \
			zynqimage.o \
			zynqmpimage.o \
			zynqmpbif.o \
			$(LIBFDT_OBJS) \
			gpimage.o \
			gpimage-common.o \
			mtk_image.o \
			$(RSA_OBJS-y)

dumpimage-objs := $(dumpimage-mkimage-objs) dumpimage.o
mkimage-objs   := $(dumpimage-mkimage-objs) mkimage.o
fit_info-objs   := $(dumpimage-mkimage-objs) fit_info.o
fit_check_sign-objs   := $(dumpimage-mkimage-objs) fit_check_sign.o
file2include-objs := file2include.o

ifneq ($(CONFIG_MX23)$(CONFIG_MX28)$(CONFIG_FIT_SIGNATURE),)
# Add CONFIG_MXS into host CFLAGS, so we can check whether or not register
# the mxsimage support within tools/mxsimage.c .
HOSTCFLAGS_mxsimage.o += -DCONFIG_MXS
endif

ifdef CONFIG_FIT_SIGNATURE
# This affects include/image.h, but including the board config file
# is tricky, so manually define this options here.
HOST_EXTRACFLAGS	+= -DCONFIG_FIT_SIGNATURE
HOST_EXTRACFLAGS	+= -DCONFIG_FIT_SIGNATURE_MAX_SIZE=$(CONFIG_FIT_SIGNATURE_MAX_SIZE)
endif

ifdef CONFIG_SYS_U_BOOT_OFFS
HOSTCFLAGS_kwbimage.o += -DCONFIG_SYS_U_BOOT_OFFS=$(CONFIG_SYS_U_BOOT_OFFS)
endif

ifneq ($(CONFIG_ARMADA_38X)$(CONFIG_ARMADA_39X),)
HOSTCFLAGS_kwbimage.o += -DCONFIG_KWB_SECURE
endif

# MXSImage needs LibSSL
ifneq ($(CONFIG_MX23)$(CONFIG_MX28)$(CONFIG_ARMADA_38X)$(CONFIG_ARMADA_39X)$(CONFIG_FIT_SIGNATURE),)
HOSTLOADLIBES_mkimage += \
	$(shell pkg-config --libs libssl libcrypto 2> /dev/null || echo "-lssl -lcrypto")

# OS X deprecate openssl in favour of CommonCrypto, supress deprecation
# warnings on those systems
ifeq ($(HOSTOS),darwin)
HOSTCFLAGS_mxsimage.o += -Wno-deprecated-declarations
HOSTCFLAGS_image-sig.o += -Wno-deprecated-declarations
HOSTCFLAGS_rsa-sign.o += -Wno-deprecated-declarations
endif
endif

HOSTCFLAGS_fit_image.o += -DMKIMAGE_DTC=\"$(CONFIG_MKIMAGE_DTC_PATH)\"

HOSTLOADLIBES_dumpimage := $(HOSTLOADLIBES_mkimage)
HOSTLOADLIBES_fit_info := $(HOSTLOADLIBES_mkimage)
HOSTLOADLIBES_fit_check_sign := $(HOSTLOADLIBES_mkimage)

hostprogs-$(CONFIG_EXYNOS5250) += mkexynosspl
hostprogs-$(CONFIG_EXYNOS5420) += mkexynosspl
HOSTCFLAGS_mkexynosspl.o := -pedantic

ifdtool-objs := $(LIBFDT_OBJS) ifdtool.o
hostprogs-$(CONFIG_X86) += ifdtool

hostprogs-$(CONFIG_MX23) += mxsboot
hostprogs-$(CONFIG_MX28) += mxsboot
HOSTCFLAGS_mxsboot.o := -pedantic

hostprogs-$(CONFIG_ARCH_SUNXI) += mksunxiboot
hostprogs-$(CONFIG_ARCH_SUNXI) += sunxi-spl-image-builder
sunxi-spl-image-builder-objs := sunxi-spl-image-builder.o lib/bch.o

hostprogs-$(CONFIG_NETCONSOLE) += ncb
hostprogs-$(CONFIG_SHA1_CHECK_UB_IMG) += ubsha1

ubsha1-objs := os_support.o ubsha1.o lib/sha1.o

HOSTCFLAGS_ubsha1.o := -pedantic

hostprogs-$(CONFIG_KIRKWOOD) += kwboot
hostprogs-$(CONFIG_ARCH_MVEBU) += kwboot
hostprogs-y += proftool
hostprogs-$(CONFIG_STATIC_RELA) += relocate-rela
hostprogs-$(CONFIG_RISCV) += prelink-riscv

hostprogs-y += fdtgrep
fdtgrep-objs += $(LIBFDT_OBJS) fdtgrep.o

hostprogs-$(CONFIG_MIPS) += mips-relocs

# We build some files with extra pedantic flags to try to minimize things
# that won't build on some weird host compiler -- though there are lots of
# exceptions for files that aren't complaint.
HOSTCFLAGS_crc32.o := -pedantic
HOSTCFLAGS_crc8.o := -pedantic
HOSTCFLAGS_md5.o := -pedantic
HOSTCFLAGS_sha1.o := -pedantic
HOSTCFLAGS_sha256.o := -pedantic

quiet_cmd_wrap = WRAP    $@
cmd_wrap = echo "\#include <../$(patsubst $(obj)/%,%,$@)>" >$@

$(obj)/lib/%.c $(obj)/common/%.c $(obj)/env/%.c:
	$(call cmd,wrap)

clean-dirs := lib common

always := $(hostprogs-y)

# Generated LCD/video logo
LOGO_H = $(objtree)/include/bmp_logo.h
LOGO_DATA_H = $(objtree)/include/bmp_logo_data.h
LOGO-$(CONFIG_LCD_LOGO) += $(LOGO_H)
LOGO-$(CONFIG_LCD_LOGO) += $(LOGO_DATA_H)
LOGO-$(CONFIG_VIDEO_LOGO) += $(LOGO_H)
LOGO-$(CONFIG_VIDEO_LOGO) += $(LOGO_DATA_H)

# Generic logo
ifeq ($(LOGO_BMP),)
LOGO_BMP= $(srctree)/$(src)/logos/denx.bmp

# Use board logo and fallback to vendor
ifneq ($(wildcard $(srctree)/$(src)/logos/$(BOARD).bmp),)
LOGO_BMP= $(srctree)/$(src)/logos/$(BOARD).bmp
else
ifneq ($(wildcard $(srctree)/$(src)/logos/$(VENDOR).bmp),)
LOGO_BMP= $(srctree)/$(src)/logos/$(VENDOR).bmp
endif
endif

endif # !LOGO_BMP

#
# Use native tools and options
# Define __KERNEL_STRICT_NAMES to prevent typedef overlaps
# Define _GNU_SOURCE to obtain the getline prototype from stdio.h
#
HOST_EXTRACFLAGS += -include $(srctree)/include/compiler.h \
		$(patsubst -I%,-idirafter%, $(filter -I%, $(UBOOTINCLUDE))) \
		-I$(srctree)/scripts/dtc/libfdt \
		-I$(srctree)/tools \
		-DUSE_HOSTCC \
		-D__KERNEL_STRICT_NAMES \
		-D_GNU_SOURCE

__build:	$(LOGO-y)

$(LOGO_H):	$(obj)/bmp_logo $(LOGO_BMP)
	$(obj)/bmp_logo --gen-info $(LOGO_BMP) > $@

$(LOGO_DATA_H):	$(obj)/bmp_logo $(LOGO_BMP)
	$(obj)/bmp_logo --gen-data $(LOGO_BMP) > $@

# Let clean descend into subdirs
subdir- += env

ifneq ($(CROSS_BUILD_TOOLS),)
override HOSTCC = $(CC)

quiet_cmd_crosstools_strip = STRIP   $^
      cmd_crosstools_strip = $(STRIP) $^; touch $@
$(obj)/.strip: $(call objectify,$(filter $(always),$(hostprogs-y)))
	$(call cmd,crosstools_strip)

always += .strip
endif
clean-files += .strip

=== roms/SLOF/board-qemu/slof/Makefile ===
# *****************************************************************************
# * Copyright (c) 2004, 2011 IBM Corporation
# * All rights reserved.
# * This program and the accompanying materials
# * are made available under the terms of the BSD License
# * which accompanies this distribution, and is available at
# * http://www.opensource.org/licenses/bsd-license.php
# *
# * Contributors:
# *     IBM Corporation - initial implementation
# ****************************************************************************/


include ../Makefile.dirs

include $(TOPBRDDIR)/config
include $(TOPCMNDIR)/make.rules

all: version.o Makefile.dep OF.ffs paflof $(SLOFCMNDIR)/xvect.bin

CPPFLAGS = -I$(LIBCMNDIR)/libbootmsg -I$(LIBCMNDIR)/libhvcall \
	   -I$(LIBCMNDIR)/libvirtio -I$(LIBCMNDIR)/libnvram \
	   -I$(LIBCMNDIR)/libusb -I$(LIBCMNDIR)/libveth \
	   -I$(LIBCMNDIR)/libe1k -I$(LIBCMNDIR)/libnet \
	   -I$(LIBCMNDIR)/libbootmenu
SLOF_LIBS = \
	$(LIBCMNDIR)/libbootmsg.a \
	$(LIBCMNDIR)/libelf.a \
	$(LIBCMNDIR)/libhvcall.a \
	$(LIBCMNDIR)/libvirtio.a \
	$(LIBCMNDIR)/libusb.a \
	$(LIBCMNDIR)/libnvram.a \
	$(LIBCMNDIR)/libveth.a \
	$(LIBCMNDIR)/libe1k.a \
	$(LIBCMNDIR)/libnet.a \
	$(LIBCMNDIR)/libbootmenu.a
BOARD_SLOF_IN = \
	$(LIBCMNDIR)/libhvcall/hvcall.in \
	$(LIBCMNDIR)/libvirtio/virtio.in \
	$(LIBCMNDIR)/libusb/usb.in \
	$(LIBCMNDIR)/libbootmsg/bootmsg.in \
	$(LIBCMNDIR)/libelf/libelf.in \
	$(LIBCMNDIR)/libnvram/libnvram.in \
	$(LIBCMNDIR)/libbases/libbases.in \
	$(LIBCMNDIR)/libveth/veth.in \
	$(LIBCMNDIR)/libe1k/e1k.in \
	$(LIBCMNDIR)/libnet/libnet.in \
	$(LIBCMNDIR)/libbootmenu/bootmenu.in
BOARD_SLOF_CODE = $(BOARD_SLOF_IN:%.in=%.code)

include $(SLOFCMNDIR)/Makefile.inc

AS1FLAGS  = $(CPPFLAGS) $(RELEASE) $(FLAG) $(CPUARCHDEF)  -Wa,-mregnames

%.o: %.S
	$(CC) $(AS1FLAGS) -o $@ -c $^

FPPINCLUDES = -I. -I$(SLOFCMNDIR)/fs -I$(SLOFCMNDIR)

USB_FFS_FILES = \
	$(SLOFCMNDIR)/fs/devices/pci-class_02.fs \
	$(SLOFCMNDIR)/fs/devices/pci-class_0c.fs \
	$(SLOFCMNDIR)/fs/usb/dev-hci.fs \
	$(SLOFCMNDIR)/fs/usb/slofdev.fs \
	$(SLOFCMNDIR)/fs/usb/dev-parent-calls.fs \
	$(SLOFCMNDIR)/fs/usb/dev-keyb.fs \
	$(SLOFCMNDIR)/fs/usb/dev-mouse.fs \
	$(SLOFCMNDIR)/fs/usb/dev-storage.fs \
	$(SLOFCMNDIR)/fs/usb/dev-hub.fs


VIO_FFS_FILES = \
	$(SLOFBRDDIR)/pci-device_1af4_1000.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1041.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1001.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1042.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1003.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1043.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1004.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1048.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1009.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1049.fs \
	$(SLOFBRDDIR)/pci-device_1af4_1050.fs \
	$(SLOFBRDDIR)/vio-hvterm.fs \
	$(SLOFBRDDIR)/vio-vscsi.fs \
	$(SLOFBRDDIR)/vio-veth.fs \
	$(SLOFBRDDIR)/rtas-nvram.fs \
	$(SLOFBRDDIR)/virtio-net.fs \
	$(SLOFBRDDIR)/virtio-serial.fs \
	$(SLOFBRDDIR)/virtio-block.fs \
	$(SLOFBRDDIR)/virtio-fs.fs \
	$(SLOFBRDDIR)/dev-null.fs \
	$(SLOFBRDDIR)/virtio-scsi.fs

# Files that should go into the ROM fs (and so have to be listed in OF.ffs):
OF_FFS_FILES = \
	$(SLOFCMNDIR)/fs/ide.fs \
	$(SLOFCMNDIR)/fs/fbuffer.fs \
	$(SLOFCMNDIR)/fs/graphics.fs \
	$(SLOFCMNDIR)/fs/generic-disk.fs \
	$(SLOFCMNDIR)/fs/dma-function.fs \
	$(SLOFCMNDIR)/fs/pci-device.fs \
	$(SLOFCMNDIR)/fs/pci-bridge.fs \
	$(SLOFCMNDIR)/fs/pci-properties.fs \
	$(SLOFCMNDIR)/fs/pci-config-bridge.fs \
	$(SLOFCMNDIR)/fs/update_flash.fs \
	$(SLOFCMNDIR)/fs/xmodem.fs \
	$(SLOFCMNDIR)/fs/scsi-disk.fs \
	$(SLOFCMNDIR)/fs/scsi-host-helpers.fs \
	$(SLOFCMNDIR)/fs/scsi-probe-helpers.fs \
	$(SLOFCMNDIR)/fs/scsi-support.fs \
	$(SLOFCMNDIR)/fs/fcode/evaluator.fs \
	$(SLOFBRDDIR)/default-font.bin \
	$(SLOFBRDDIR)/pci-phb.fs \
	$(SLOFBRDDIR)/rtas.fs \
	$(SLOFBRDDIR)/pci-device_1234_1111.fs \
	$(SLOFBRDDIR)/pci-device_1013_00b8.fs \
	$(SLOFBRDDIR)/pci-device_8086_100e.fs \
	$(SLOFBRDDIR)/e1k.fs \
	$(SLOFBRDDIR)/qemu-vga.fs \
	$(FCODE_FFS_FILES)

# Uncomment the following line to enable the USB code:
OF_FFS_FILES += $(USB_FFS_FILES)

OF_FFS_FILES += $(VIO_FFS_FILES)

OF_FFS_FILES := $(OF_FFS_FILES:%.fs=%.fsi)

OF.ffs: Makefile $(SLOFCMNDIR)/Makefile.inc $(OF_FFS_FILES)
	$(MAKE) create_OF_ffs

# Rules for cleaning up:
.PHONY: clean_here clean distclean

clean_here:
	rm -f *.o OF.fsi OF.ffs

clean: clean_here clean_slof

distclean: clean_here distclean_slof

=== debian/changelog ===
qemu (1:4.2-3ubuntu6.30) focal-security; urgency=medium

  * SECURITY UPDATE: denial of service
    - debian/patches/CVE-2023-3019-pre1.patch: Add definition for
      MemReentrancyGuard struct and include for header file
    - debian/patches/CVE-2023-3019-1.patch: net: Provide
      MemReentrancyGuard * to qemu_new_nic()
    - debian/patches/CVE-2023-3019-2.patch: net: Update
      MemReentrancyGuard for NIC
    - CVE-2023-3019

 -- Bruce Cable <bruce.cable@canonical.com>  Mon, 21 Oct 2024 10:09:42 +1100

qemu (1:4.2-3ubuntu6.29) focal-security; urgency=medium

  * SECURITY REGRESSION: 9pfs restrictions on sockets (LP: #2065579)
    - debian/patches/ubuntu/lp-2065579-9pfs-allow-sockets.patch: allow
      sockets and FIFOs to be opened in hw/9pfs/9p-util.h. The fix for
      CVE-2023-2861 was too restrictive for some use-cases.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 05 Jun 2024 12:25:53 -0400

qemu (1:4.2-3ubuntu6.28) focal-security; urgency=medium

  * SECURITY UPDATE: infinite loop in USB xHCI controller
    - debian/patches/CVE-2020-14394.patch: Fix unbounded loop in
      xhci_ring_chain_length() in hw/usb/hcd-xhci.c.
    - CVE-2020-14394
  * SECURITY UPDATE: code execution in TCG Accelerator
    - debian/patches/CVE-2020-24165.patch: fix race in cpu_exec_step_atomic
      in accel/tcg/cpu-exec.c.
    - CVE-2020-24165
  * SECURITY UPDATE: OOB access in ATI VGA device
    - debian/patches/CVE-2021-3638.patch: Fix buffer overflow in ati_2d_blt
      in hw/display/ati_2d.c.
    - CVE-2021-3638
  * SECURITY UPDATE: OOB read in RDMA device
    - debian/patches/CVE-2023-1544.patch: protect against buggy or
      malicious guest driver in hw/rdma/vmw/pvrdma_main.c.
    - CVE-2023-1544
  * SECURITY UPDATE: 9pfs special file access
    - debian/patches/CVE-2023-2861.patch: prevent opening special files in
      fsdev/virtfs-proxy-helper.c, hw/9pfs/9p-util.h.
    - CVE-2023-2861
  * SECURITY UPDATE: heap overflow in crypto device
    - debian/patches/CVE-2023-3180.patch: verify src&dst buffer length for
      sym request in hw/virtio/virtio-crypto.c.
    - CVE-2023-3180
  * SECURITY UPDATE: DoS in VNC server
    - debian/patches/CVE-2023-3354.patch: remove io watch if TLS channel is
      closed during handshake in include/io/channel-tls.h,
      io/channel-tls.c.
    - CVE-2023-3354
  * SECURITY UPDATE: disk offset 0 access
    - debian/patches/CVE-2023-5088.patch: cancel async DMA operation before
      resetting state in hw/ide/core.c.
    - CVE-2023-5088

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 30 Nov 2023 14:45:57 -0500

qemu (1:4.2-3ubuntu6.27) focal-security; urgency=medium

  * SECURITY UPDATE: user-after-free issue
    - debian/patches/CVE-2022-1050.patch: Protect against buggy or
      malicious guest driver
    - CVE-2022-1050
  * SECURITY UPDATE: Out-of-bounds read
    - debian/patches/CVE-2022-4144-*.patch: Have qxl_log_command Return
      early if no log_cmd handler; Document qxl_phys2virt(); Pass requested
      buffer size to qxl_phys2virt(); Avoid buffer overrun in qxl_phys2virt;
      Assert memory slot fits in preallocated MemoryRegion
    - CVE-2022-4144
  * SECURITY UPDATE: reentrancy problem
    - debian/patches/CVE-2023-0330.patch: Fix reentrancy issues in the LSI
      controller
    - CVE-2023-0330

 -- Nishit Majithia <nishit.majithia@canonical.com>  Tue, 13 Jun 2023 16:58:54 +0530

qemu (1:4.2-3ubuntu6.26) focal; urgency=medium

  * d/p/u/lp-1999885-s390x-tod-kvm-don-t-save-restore-the-TOD-in-PV-guest.patch:
    avoid timer issues in s390x secure execution guests (LP: #1999885)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 23 Mar 2023 08:18:28 +0100

qemu (1:4.2-3ubuntu6.25) focal; urgency=medium

  [ Brett Milford ]
  * d/p/u/lp1994002-migration-Read-state-once.patch: Fix for libvirt
    error 'migration was active, but no RAM info was set' (LP: #1994002)

  [ Mauricio Faria de Oliveira ]
  * d/p/u/lp2009048-vfio_map_dma_einval_amd_iommu_1tb.patch: Add hint
    to VFIO_MAP_DMA error on AMD IOMMU for VMs with ~1TB+ RAM (LP: #2009048)

 -- Mauricio Faria de Oliveira <mfo@canonical.com>  Thu, 02 Mar 2023 18:07:21 -0300

qemu (1:4.2-3ubuntu6.24) focal-security; urgency=medium

  * SECURITY UPDATE: DMA reentrancy issue
    - debian/patches/CVE-2021-3750.patch: Introduce MemTxAttrs::memory
      field and MEMTX_ACCESS_ERROR
    - CVE-2021-3750
  * SECURITY UPDATE: use-after-free vulnerability
    - debian/patches/CVE-2022-0216-*.patch: fix use-after-free in
      lsi_do_msgout
    - CVE-2022-0216

 -- Nishit Majithia <nishit.majithia@canonical.com>  Thu, 08 Dec 2022 14:45:56 +0530

qemu (1:4.2-3ubuntu6.23) focal-security; urgency=medium

  * SECURITY UPDATE: heap overflow in floppy disk emulator
    - debian/patches/CVE-2021-3507.patch: prevent end-of-track overrun in
      hw/block/fdc.c.
    - CVE-2021-3507
  * SECURITY UPDATE: integer overflow in QXL display device emulation
    - debian/patches/CVE-2021-4206.patch: check width and height in
      hw/display/qxl-render.c, hw/display/vmware_vga.c, ui/cursor.c.
    - CVE-2021-4206
  * SECURITY UPDATE: heap overflow in QXL display device emulation
    - debian/patches/CVE-2021-4207.patch: fix race condition in qxl_cursor
      in hw/display/qxl-render.c.
    - CVE-2021-4207
  * SECURITY UPDATE: memory leakage in virtio-net device
    - debian/patches/CVE-2022-26353.patch: fix map leaking on error during
      receive in hw/net/virtio-net.c.
    - CVE-2022-26353
  * SECURITY UPDATE: memory leakage in vhost-vsock device
    - debian/patches/CVE-2022-26354.patch: detach the virqueue element in
      case of error in hw/virtio/vhost-vsock.c.
    - CVE-2022-26354

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 09 Jun 2022 11:35:04 -0400

qemu (1:4.2-3ubuntu6.22) focal; urgency=medium

  * d/p/u/lp-1967814-*: avoid interpreting failed scsi requests as
    good which could lead to silent data corruption (LP: #1967814)


=== debian/control ===
# autogenerated file, please edit debian/control-in
Source: qemu
Section: otherosfs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>,
	Riku Voipio <riku.voipio@iki.fi>,
	Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper (>= 12),
# In comments below we also specify (system-specific) arguments
# to qemu's configure script, -- optional features which depend
# on build-dependencies.
# pc-bios/*.dts => *.dtb (PPC firmware)
 device-tree-compiler,
 python3:any,
# --enable-docs
 texinfo, python3-sphinx,
# iasl (from acpica-tools) is used only in a single test these days, not for building
# acpica-tools,
# --enable-linux-aio	linux-*
 libaio-dev [linux-any],
# --audio-drv-list=pa,alsa,oss	linux-*
# --audio-drv-list=pa,oss	kfreebsd-*
 libpulse-dev,
 libasound2-dev [linux-any],
# for virtfs
# --enable-attr
 libattr1-dev,
# bluetooth subsystem got deprecated by upstream
# --disable-bluez
# --enable-brlapi
 libbrlapi-dev,
# --enable-virtfs	linux-*
# needed for virtfs
 libcap-dev [linux-any],
# --enable-cap-ng	linux-*
 libcap-ng-dev [linux-any],
# --enable-curl
 libcurl4-gnutls-dev,
# --enable-fdt
 libfdt-dev,
# --enable-gnutls
 gnutls-dev,
# --enable-gtk --enable-vte
 libgtk-3-dev, libvte-2.91-dev,
# --enable-libiscsi
 libiscsi-dev (>> 1.9.0~),
# --enable-curses
 libncursesw5-dev,
# --enable-virglrenderer
 libvirglrenderer-dev,
# --enable-opengl
 libepoxy-dev, libdrm-dev, libgbm-dev,
# --enable-numa	i386|amd64|ia64|mips|mipsel|powerpc|powerpcspe|x32|ppc64|ppc64el|arm64|sparc|s390x|riscv64
 libnuma-dev   [i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64],
# --enable-smartcard
 libcacard-dev,
 libpixman-1-dev,
# --enable-rbd		amd64|arm64|armel|armhf|i386|mips64el|mipsel|ppc64el|s390x|ppc64|sparc64
 librbd-dev            [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64 sparc64],
# glusterfs is debian-only since ubuntu/glusterfs is in universe (MIR LP: #1274247)
# before buster it was glusterfs-common so keep it for now for bpo
# --enable-vnc-sasl
 libsasl2-dev,
# --disable-sdl
# --enable-seccomp	amd64|arm64|armel|armhf|i386|mips64el|mipsel|ppc64el|s390x|hppa|powerpc|ppc64|riscv64|x32
 libseccomp-dev        [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x hppa powerpc ppc64 riscv64 x32],
# --enable-slirp=system
 libslirp-dev,
# --enable-spice	linux-amd64|linux-i386|linux-arm64
 libspice-server-dev (>= 0.12.5~) [linux-amd64 linux-i386 linux-arm64],
 libspice-protocol-dev (>= 0.12.3~) [linux-amd64 linux-i386 linux-arm64],
# --enable-rdma
 librdmacm-dev, libibverbs-dev, libibumad-dev,
# --enable-libusb	linux-*
 libusb-1.0-0-dev (>= 2:1.0.13~) [linux-any],
# --enable-usb-redir	linux-*
 libusbredirparser-dev (>= 0.6~) [linux-any],
# --enable-libssh
 libssh-dev,
# vde is debian-only since ubuntu/vde2 is in universe
 libxen-dev [linux-amd64 linux-i386],
# --enable-nettle
 nettle-dev,
## always enabled: --enable-uuid
 uuid-dev,
# --enable-xfsctl	linux-*
 xfslibs-dev [linux-any],
# always needed
 zlib1g-dev,
# other optional features we enable
# no configure flag, needed for qga
 libudev-dev,
# --enable-vnc
# --enable-vnc-jpeg
 libjpeg-dev,
# --enable-vnc-png
 libpng-dev,
# --enable-libpmem	linux-amd64|linux-arm64
 libpmem-dev [linux-amd64 linux-arm64],
# --enable-kvm		linux-*
# --enable-vhost-net	linux-*	# is it really linux-specific?
##--enable-lzo todo, for (memory) dumps
##--enable-netmap todo bsd
##--enable-xen-pci-passthrough todo
##--with-iconv (libiconv for curses wide char support)
## libudev?
## auth-pam - for auth for vnc&Co using PAM
## gio-2.0 - for -display=spice-app
Build-Depends-Indep:
 gcc-s390x-linux-gnu,
# libc6.1-dev-alpha-cross isn't really needed but the code,
# for whatever reason, #include's string.h which needs libc6.1-dev
 gcc-alpha-linux-gnu, libc6.1-dev-alpha-cross,
# skiboot firmware
 gcc-powerpc64-linux-gnu,
Build-Conflicts: oss4-dev
Standards-Version: 3.9.8
Homepage: http://www.qemu.org/
XS-Debian-Vcs-Browser: https://salsa.debian.org/qemu-team/qemu
XS-Debian-Vcs-Git: https://salsa.debian.org/qemu-team/qemu.git
Vcs-Browser: https://git.launchpad.net/ubuntu/+source/qemu
Vcs-Git: https://git.launchpad.net/ubuntu/+source/qemu

Package: qemu
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Section: oldlibs
Depends: ${misc:Depends}
Description: fast processor emulator, dummy package
 QEMU is a fast processor emulator. Once upon a time there was only one
 package named `qemu', with all functionality included. These days, qemu
 become large and has been split into numerous packages. Different packages
 provides entirely different services, and it is very unlikely one will
 need all of them together. So current `qemu' package makes no sense anymore,
 and is becoming a dummy package.
 .
 If you want full system emulation of some architecture, install one or more
 of qemu-system-ARCH packages. If you want user-mode emulation, install
 qemu-user or qemu-user-static package. If you need utilities, use qemu-utils
 package.
 .
 This package can safely be removed.

Package: qemu-system
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Depends: ${misc:Depends},
 qemu-system-arm,
 qemu-system-mips,
 qemu-system-ppc,
 qemu-system-sparc,
 qemu-system-x86,
 qemu-system-s390x,
 qemu-system-misc
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This metapackage provides the full system emulation binaries for all supported
 targets, by depending on all per-architecture system emulation packages which
 QEMU supports.

Package: qemu-block-extra
Architecture: amd64 arm arm64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Enhances: qemu-utils, qemu-system-misc,
 qemu-system-arm, qemu-system-mips, qemu-system-sparc, qemu-system-x86
Description: extra block backend modules for qemu-system and qemu-utils
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides extra block device backend modules for qemu-system
 emulation and qemu-img from qemu-utils package, which are rarely used and
 has extra dependencies.

Package: qemu-system-data
Architecture: all
Multi-Arch: foreign
Conflicts: sgabios, qemu-skiboot
Replaces: qemu-system-common (<< 1:2.12+dfsg-2~), sgabios,
    qemu-system-s390x (<< 1:3.1+dfsg-2ubuntu1~)
Breaks: qemu-system-s390x (<< 1:3.1+dfsg-2ubuntu1~)
Provides: qemu-keymaps, sgabios, qemu-skiboot
Depends: ${misc:Depends}
Description: QEMU full system emulation (data files)
 This package provides architecture-neutral data files
 (such as keyboard definitions, icons) for system-mode
 QEMU emulation (qemu-system-*) packages.

Package: qemu-system-common
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Replaces: qemu-system-data (<< 1:3.1+dfsg-1~), qemu-utils (<< 1:4.2-1ubuntu1~)
Breaks:   qemu-system-data (<< 1:3.1+dfsg-1~), qemu-utils (<< 1:4.2-1ubuntu1~)
Depends: ${misc:Depends}, ${shlibs:Depends},
 qemu-block-extra (= ${binary:Version}),
 powerpc-utils [ppc64el],
# to fix wrong acl for newly created device node on ubuntu:
 acl
Description: QEMU full system emulation binaries (common files)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides common files needed for target-specific
 full system emulation (qemu-system-*) packages.

Package: qemu-system-gui
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: QEMU full system emulation binaries (user interface and audio support)
 This package provides local graphical user interface (currently GTK)
 and audio backends for full system emulation (qemu-system-*) packages.

Package: qemu-system-misc
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, qemu-system-common (>> 1:2.12~), qemu-system-data (>> ${source:Version}~),
Recommends: qemu-system-gui (= ${binary:Version}), qemu-utils,
# alpha uses vgabios
# alpha m68k sh4 uses bootroms
 seabios, ipxe-qemu (>= 1.0.0+git-20131111.c3d1e78-1~)
Suggests: samba, vde2, qemu-block-extra (= ${binary:Version}),
Provides: ${sysprovides:misc}
Description: QEMU full system emulation binaries (miscellaneous)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, M68k (ColdFire), MicroBlaze, and SH4
 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries to emulate
 various other hardware which did not made into separate packages.
 Emulators for the following architectures are provided:
  ${sysarch:misc}.
 .
 In system emulation mode QEMU emulates a full system, including a processor
 and various peripherals.  It enables easier testing and debugging of system
 code.  It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-arm
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, qemu-system-common (>> 1:2.12~), qemu-system-data (>> ${source:Version}~),
Recommends: qemu-system-gui (= ${binary:Version}), qemu-utils,
# aarch64 arm uses bootroms
 ipxe-qemu (>= 1.0.0+git-20131111.c3d1e78-1~),
 ipxe-qemu-256k-compat-efi-roms,
 qemu-efi-aarch64, qemu-efi-arm
Suggests: samba, vde2, qemu-block-extra (= ${binary:Version}),
Provides: ${sysprovides:arm}
Description: QEMU full system emulation binaries (arm)
 QEMU is a fast processor emulator: currently the package supports
 ARM emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries to emulate
 the following arm hardware: ${sysarch:arm}.
 .
 In system emulation mode QEMU emulates a full system, including a processor
 and various peripherals.  It enables easier testing and debugging of system
 code.  It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-mips
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# get DEB_VERSION
include /usr/share/dpkg/pkg-info.mk
# get DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_TYPE DEB_HOST_MULTIARCH DEB_BUILD_GNU_TYPE
include /usr/share/dpkg/architecture.mk
# get CFLAGS LDFLAGS etc
include /usr/share/dpkg/buildflags.mk

libdir = /usr/lib/${DEB_HOST_MULTIARCH}

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
VENDOR := UBUNTU
DEB_BUILD_PARALLEL = yes
else
VENDOR := DEBIAN
endif

AUTOGENERATED:= qemu-block-extra.prerm qemu-block-extra.postrm
PKGVERSION := $(shell printf "Debian ${DEB_VERSION}" | tr --complement '[:alnum:]+-.~' '_')

# support parallel build using DEB_BUILD_OPTIONS=parallel=N
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# verbose build
V ?= 1

# list of packages we're supposed to build
BUILD_PACKAGES = $(call dpkg_late_eval,BUILD_PACKAGES,dh_listpackages)

enable_system = $(if $(filter qemu-system,${BUILD_PACKAGES}),enable,disable)
enable_linux_user = $(if $(filter qemu-user,${BUILD_PACKAGES}),enable,disable)

FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu

ALPHAEV67_CROSSPFX = alpha-linux-gnu-
PPC64_CROSSPFX = powerpc64-linux-gnu-

# we add another set of configure options from debian/control
common_configure_opts = \
	--with-pkgversion="Debian $(DEB_VERSION)" \
	--extra-cflags="$(CFLAGS) $(CPPFLAGS)" --extra-ldflags="$(LDFLAGS) -Wl,--as-needed" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=${libdir} \
	--libexecdir=/usr/lib/qemu \
	--firmwarepath=${FIRMWAREPATH} \
	--localstatedir=/var \
	--disable-blobs \
	--disable-strip \
	--interp-prefix=/etc/qemu-binfmt/%M \
	--localstatedir=/var \
	--with-git-submodules=ignore \

# Cross compiling support
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
common_configure_opts  += --cross-prefix=$(DEB_HOST_GNU_TYPE)-
endif

ifeq ($(DEB_TARGET_ARCH), hppa)
# allow configure to run on unsupported arches to build qemu-utils and the like
common_configure_opts += --enable-tcg-interpreter
endif

ifeq (${enable_system},enable)

# list of system (softmmu) targets, from ./configure
system_targets = \
 i386 x86_64 alpha aarch64 arm cris lm32 hppa m68k microblaze microblazeel \
 mips mipsel mips64 mips64el moxie nios2 or1k ppc ppc64 riscv32 riscv64 \
 sh4 sh4eb sparc sparc64 s390x tricore xtensa xtensaeb unicore32

# qemu-system subpackages, from d/control
ifeq ($(VENDOR),UBUNTU)
sys_systems = arm mips ppc sparc x86 s390x
else
sys_systems = arm mips ppc sparc x86
endif
systems = ${sys_systems} misc
sysarch_arm   = $(filter aarch64 arm,${system_targets})
sysarch_mips  = $(filter mips mipsel mips64 mips64el,${system_targets})
sysarch_ppc   = $(filter ppc ppc64,${system_targets})
sysarch_sparc = $(filter sparc sparc64,${system_targets})
sysarch_x86   = $(filter i386 x86_64,${system_targets})
sysarch_s390x = $(filter s390x,${system_targets})
sysarch_misc  = $(filter-out $(foreach s,${sys_systems},${sysarch_$s}),${system_targets})
sysarch_x86   = $(filter i386 x86_64,${system_targets})

else

systems =

endif # enable_system

ifeq (${enable_linux_user},enable)

# list of linux-user targets, from ./configure
user_targets = \
 i386 x86_64 alpha aarch64 aarch64_be arm armeb cris hppa m68k microblaze microblazeel \
 mips mipsel mips64 mips64el mipsn32 mipsn32el nios2 or1k \
 ppc ppc64 ppc64abi32 ppc64le riscv32 riscv64 sh4 sh4eb sparc sparc64 sparc32plus \
 s390x tilegx xtensa xtensaeb

endif	# enable_linux_user

b/configure-stamp: configure
	dh_testdir

	for f in ${AUTOGENERATED} ; do \
        sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' \
	        -e 's%@PKGVERSION@%${PKGVERSION}%g' \
			< debian/$$f.in  > debian/$$f ; \
    done

	# system build
	rm -rf b/qemu; mkdir -p b/qemu
	cd b/qemu && \
	    ../../configure ${common_configure_opts} --disable-user \
		--${enable_system}-system \
		--${enable_linux_user}-linux-user \
		--disable-xen \
		--enable-modules \
		--enable-module-upgrades \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		$(QEMU_CONFIGURE_OPTIONS) || \
	 { echo ===== CONFIGURE FAILED ===; tail -n 50 b/qemu/config.log; exit 1; }

# switch some simple UI and simple audio modules to be built-ins,
# but keep more complex to be modules to move to a separate package
	sed -i -r 's/(CONFIG_(CURSES|-GTK|-SDL|AUDIO_(-PA|OSS|ALSA|-SDL)))=m/\1=y/' \
		b/qemu/config-host.mak

ifeq ($(VENDOR),UBUNTU)
ifneq ($(filter $(DEB_HOST_ARCH),amd64 i386),)
# like above but with:
#  --enable-xen
#  --disable-linux-user (not needed for this binary)
#  reduced --target-list as needed for xen
#  xen can only be configured on x86, so skip other build architectures
	# system build for qemu-system-x86-xen
	rm -rf b/qemu-xen; mkdir -p b/qemu-xen
	cd b/qemu-xen && \
	    ../../configure ${common_configure_opts} --disable-user \
		--${enable_system}-system \
		--disable-linux-user \
		--enable-xen \
		--target-list="aarch64-softmmu arm-softmmu i386-softmmu x86_64-softmmu"
		--enable-modules \
		--enable-module-upgrades \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		$(QEMU_CONFIGURE_OPTIONS) || \
	 { echo ===== CONFIGURE FAILED ===; tail -n 50 b/qemu-xen/config.log; exit 1; }
# same config as the main build.
	sed -i -r 's/(CONFIG_(CURSES|-GTK|-SDL|AUDIO_(-PA|OSS|ALSA|-SDL)))=m/\1=y/' \
		b/qemu-xen/config-host.mak
endif
endif

ifneq ($(filter $(DEB_HOST_ARCH),amd64),)
	# minimal system (for qboot/microvm - https://github.com/bonzini/qboot)
	rm -rf b/qemu-microvm; mkdir -p b/qemu-microvm
	cd b/qemu-microvm && \
		../../configure ${common_configure_opts} --disable-user \
		--enable-system --enable-kvm \
		--disable-linux-user --disable-modules --disable-docs \
		--disable-libssh --disable-tcmalloc --disable-glusterfs \
		--disable-seccomp --disable-bzip2 --disable-slirp --disable-vde \
		--disable-netmap --disable-hax --disable-hvf --disable-whpx \
		--disable-cocoa --disable-lzfse \
		--disable-guest-agent --disable-guest-agent-msi --disable-tools \
		--disable-gnutls --disable-gcrypt --disable-auth-pam \
		--disable-replication --disable-vxhs --disable-bochs --disable-cloop \
		--disable-dmg --disable-parallels --disable-qed --disable-vdi \
		--disable-sheepdog --disable-capstone --disable-libpmem --disable-plugins \
		--disable-snappy --disable-lzo --disable-usb-redir \
		--disable-libusb --disable-smartcard --disable-libnfs  \
		--disable-libiscsi --disable-rbd  --disable-spice --disable-attr \
		--disable-cap-ng --disable-linux-aio --disable-brlapi \
		--disable-virglrenderer --disable-vnc-jpeg --disable-vnc-sasl \
		--disable-vnc-png --disable-rdma --disable-pvrdma --disable-bluez \
		--disable-fdt --disable-curl --disable-curses --disable-sdl \
		--disable-gtk  --disable-tpm --disable-vte --disable-vnc  \
		--disable-xen --disable-opengl \
		--target-list="x86_64-softmmu i386-softmmu"\
		--audio-drv-list="" --disable-xfsctl --disable-vvfat \
		--disable-iconv --disable-nettle \
		--disable-tcg-interpreter --disable-tcg \
		--without-default-devices \
		$(QEMU_CONFIGURE_OPTIONS) || \
	 { echo ===== CONFIGURE FAILED ===; tail -n 50 b/qemu-microvm/config.log; exit 1; }
endif

ifeq ($(enable_linux_user),enable)
# do not use debian/configure-opts here, all optional stuff will be enabled
# automatically, dependencies are already verified in the main build
	rm -rf b/user-static; mkdir b/user-static
	cd b/user-static && \
	    ../../configure ${common_configure_opts} \
		--static --disable-system --disable-xen \
		--target-list="$(addsuffix -linux-user,${user_targets})"
endif
	touch $@

build-arch: b/build-stamp
b/build-stamp: b/configure-stamp
	dh_testdir

	# system and utils build
	$(MAKE) -C b/qemu V=${V}
ifeq (${enable_system},enable)
	rm -f b/qemu/pc-bios/bamboo.dtb b/qemu/pc-bios/canyonlands.dtb
	dtc -o b/qemu/pc-bios/bamboo.dtb pc-bios/bamboo.dts
